<?php

class journal_calendar {

    var $html      = "";

    function journal_calendar()
    {
		global $ibforums, $journal;

		// Loading skin
		$this->html     = $journal->load_template('skin_jcalendar');
	}

	// Show calendar
	function show_calendar()
	{
		global $ibforums, $DB, $journal;

		$month = array( $ibforums->lang['j_M1'], $ibforums->lang['j_M2'], $ibforums->lang['j_M3'],
						$ibforums->lang['j_M4'], $ibforums->lang['j_M5'], $ibforums->lang['j_M6'],
						$ibforums->lang['j_M7'], $ibforums->lang['j_M8'], $ibforums->lang['j_M9'],
						$ibforums->lang['j_M10'], $ibforums->lang['j_M11'], $ibforums->lang['j_M12']);

		// save offset
		$offset = $journal->get_time_offset();

		// get selected mon and year
		list($cur_mon, $cur_year) = explode(",",gmdate( 'n,Y', time() + $offset));

		$sel_mon = (!intval($ibforums->input['mon'])) ? $cur_mon : intval($ibforums->input['mon']);
		$sel_year  = (!intval($ibforums->input['year'])) ? $cur_year : intval($ibforums->input['year']);

		if (!checkdate($sel_mon, 1 , $sel_year))
		{
			$sel_mon = $cur_mon;
			$sel_year = $cur_year;
		}

		// difference betwen local time and user time
		$diff_date = mktime(0,0,0,1,1,1999) - (gmmktime(0,0,0,1,1,1999) - $offset);

		// make start of this month
		$db_start_date = mktime(0,0,0,$sel_mon,1,$sel_year) - $diff_date;

		// make end of this month
		$db_end_date = mktime(23,59,59,$sel_mon+1,0,$sel_year) - $diff_date;


		$day_posts = array();
		$day_comments = array();
		$user_link = "";

		// main calendar or user calendar ?
		if ($journal->users['id'])
		{
			// user calendar
			$q_extra = " AND p.journal_id='".$journal->users['id']."'";
			$user_link = "user=".$journal->users['id']."&amp;";
		}
		else
		{
			// main calendar
			$ufriends = "";
			// is a member ?
			if ($ibforums->member['id'])
			{
				// yes. cache ufriends
				$DB->query("SELECT member_id FROM ibf_jfriends WHERE friend_id='".$ibforums->member['id']."'");
				while ($r = $DB->fetch_row())
				{
					$ufriend[$r['member_id']] = $r['member_id'];
				}
				if (count($ufriend) > 0) $ufriends = implode(",",$ufriend);
			}


			if ($ibforums->member['g_j_modview'])
			{
				$q_extra = "";
			}
			else
			{
				if ($ibforums->member['id'] == 0)
				{
					// show only public non blocked journal
					$q_extra = " AND me.j_blocked <> 1 AND me.j_public = 1";
				}
				else
				{
					if ($ufriends != "")
					{
						$q_extra = " AND me.j_blocked <> 1 AND (me.j_public = 1 OR me.j_public = 3 OR (me.j_public = 2 AND p.journal_id IN(".$ufriends.")))";
					}
					else
					{
						$q_extra = " AND me.j_blocked <> 1 AND (me.j_public = 1 OR me.j_public = 3)";
					}
				}
			}
		}

		// cache database info
		$DB->query("SELECT p.post_date, p.pid, me.j_public, me.id
					FROM ibf_jposts p
					LEFT JOIN ibf_member_extra me ON (me.id=p.journal_id)
					WHERE p.post_date > '".$db_start_date."'
					AND p.post_date < '".$db_end_date."'".$q_extra."
					ORDER BY p.post_date ASC");

		while ($r = $DB->fetch_row())
		{
			$day_posts[gmdate('j',$r['post_date']+$offset)] ++;
		}
		$DB->free_result();

		$DB->query("SELECT c.post_date, p.pid, me.j_public
					FROM ibf_jcomments c
					LEFT JOIN ibf_jposts p ON (p.pid=c.post_id)
					LEFT JOIN ibf_member_extra me ON (me.id=c.owner_id)
					WHERE c.post_date > '".$db_start_date."'
					AND c.post_date < '".$db_end_date."'".$q_extra."
					ORDER BY c.post_date ASC");
		while ($r = $DB->fetch_row())
		{
			$day_comments[gmdate('j',$r['post_date']+$offset)] ++;
		}
		$DB->free_result();

		$db_start_date = $db_start_date + $diff_date;
		$time_start = getdate($db_start_date);

		// get monday first (European)
		if ($time_start['wday'] == 0) $time_start['wday'] = 6;
		else $time_start['wday'] --;

		// make links
		$next_year = $sel_year;
		$next_mon = $sel_mon + 1;
		if ($next_mon > 12)
		{
			$next_year ++;
			$next_mon = 1;
		}
		$prev_year = $sel_year;
		$prev_mon = $sel_mon - 1;
		if ($prev_mon < 1)
		{
			$prev_year --;
			$prev_mon = 12;
		}

		$links['next'] = "<a href=\"".$journal->base_url.$user_link."list=calendar&amp;mon=".$next_mon."&amp;year=".$next_year."\">".$month[$next_mon-1]." ".$next_year."</a>";
		$links['prev'] = "<a href=\"".$journal->base_url.$user_link."list=calendar&amp;mon=".$prev_mon."&amp;year=".$prev_year."\">".$month[$prev_mon-1]." ".$prev_year."</a>";

		// start calendar
		$html = $this->html->j_cal_start($month[$sel_mon-1]." ".$sel_year,$links);

		// draw blank row
		for ($i=0;$i<$time_start['wday'];$i++) $html .= $this->html->j_cal_blank("style='line-height:300%'");

		// show this month
		while ($time_start['mon'] == $sel_mon)
		{
			if ($day_posts[$time_start['mday']])
				$record = "<a style='text-decoration:none;color:0033AA' href=\"".$journal->base_url.$user_link."list=allpost&amp;year=".$sel_year."&amp;mon=".$sel_mon."&amp;day=".$time_start['mday']."\" title='{$ibforums->lang['j_tips_allpost']}'>".$ibforums->lang['j_cal_records']." ".$day_posts[$time_start['mday']]."</a><br />";
			else
				$record = "<span style='color:CCCCCC'>".$ibforums->lang['j_cal_records']." 0</span><br />";

			if ($day_comments[$time_start['mday']])
				$comment = "<a style='text-decoration:none;color:0033AA' href=\"".$journal->base_url.$user_link."list=allcomm&amp;year=".$sel_year."&amp;mon=".$sel_mon."&amp;day=".$time_start['mday']."\" title='{$ibforums->lang['j_tips_allcomm']}'>".$ibforums->lang['j_cal_comments']." ".$day_comments[$time_start['mday']]."</a><br />";
			else
				$comment = "<span style='color:CCCCCC'>".$ibforums->lang['j_cal_comments']." 0</span><br />";

			$html .= $this->html->j_cal_day("<br /><span style='font-size:16px'><b>".$time_start['mday']."</b></span><br />".$record.$comment,"style='font-size:10px'");

			if ($time_start['wday'] == 6) $html .= $this->html->j_cal_endweek();

			// next day
			$db_start_date += 86400;
			$time_start = getdate($db_start_date);
			if ($time_start['wday'] == 0) $time_start['wday'] = 6;
			else $time_start['wday'] --;
		}

		// draw blank row if need
		if ($time_start['wday'] != 0)
		{
			for ($i=0;$i<(7-$time_start['wday']);$i++) $html .= $this->html->j_cal_blank("style='line-height:300%'");
		}

		// make month dropdown
		for ($i = 1;$i <= 12 ;$i++)
		{
			$m_drop .= "<option value='$i'";
			$m_drop .= ($i == $sel_mon) ? " selected='selected'" : "";
			$m_drop .= ">".$month[$i-1]."</option>\n";
		}

		// make year dropdown
		$ibforums->vars['start_year'] = (isset($ibforums->vars['start_year'])) ? $ibforums->vars['start_year'] : 2001;
		$ibforums->vars['year_limit'] = (isset($ibforums->vars['year_limit'])) ? $ibforums->vars['year_limit'] : 5;

		for ($i = $ibforums->vars['start_year']; $i <= $cur_year + $ibforums->vars['year_limit']; $i++ )
		{
			$y_drop .= "<option value='$i'";
			$y_drop .= ($i == $sel_year) ? " selected='selected'" : "";
			$y_drop .= ">".$i."</option>\n";
    	}

		// end
		if ($journal->users['id']) $users = "<input type='hidden' name='user' value='".$journal->users['id']."' />";
		else $users = "";

		$html .= $this->html->j_cal_end($m_drop,$y_drop,$users);

		$journal->nav[] = $ibforums->lang['j_calendar_list'];
		return $html;
	}


	// show all posts in selected days
	function show_posts()
	{
		global $ibforums, $DB, $journal;

		// -----------------------------------
		// Make date
		// -----------------------------------

		// save offset
		$offset = $journal->get_time_offset();

		// get selected mon, year and day
		list($cur_day, $cur_mon, $cur_year) = explode(",",gmdate( 'j,n,Y', time() + $offset));

		$sel_mon = (!intval($ibforums->input['mon'])) ? $cur_mon : intval($ibforums->input['mon']);
		$sel_year  = (!intval($ibforums->input['year'])) ? $cur_year : intval($ibforums->input['year']);
		$sel_day  = (!intval($ibforums->input['day'])) ? $cur_day : intval($ibforums->input['day']);

		if (!checkdate($sel_mon, $sel_day , $sel_year))
		{
			$sel_mon = $cur_mon;
			$sel_year = $cur_year;
			$sel_day = $cur_day;
		}

		// difference betwen local time and user time
		$diff_date = mktime(0,0,0,1,1,1999) - (gmmktime(0,0,0,1,1,1999) - $offset);

		// make start of this day
		$db_start_date = mktime(0,0,0,$sel_mon,$sel_day,$sel_year) - $diff_date;

		// make end of this day
		$db_end_date = mktime(23,59,59,$sel_mon,$sel_day,$sel_year) - $diff_date;

		if (isset($ibforums->input['days']) and intval($ibforums->input['days']) > 1)
		{
            $days = intval($ibforums->input['days']);
			if ($days > 10) $days = 10;

			$db_start_date = $db_end_date - (86400 * $days) + 1;
		}


		// -----------------------------------
		// Cache ufriends
		// -----------------------------------

		$ufriends = "";
		$ufriend = array();
		// is a member ?
		if ($ibforums->member['id'])
		{
			// yes. cache ufriends
			$DB->query("SELECT member_id FROM ibf_jfriends WHERE friend_id='".$ibforums->member['id']."'");
			while ($r = $DB->fetch_row())
			{
				$ufriend[$r['member_id']] = $r['member_id'];
			}
			if (count($ufriend) > 0) $ufriends = implode(",",$ufriend);
		}

		$html = "";
		$user_link = "";

		if ($journal->users['id'])
		{
			// make user journal query
			$q_extra = " AND p.journal_id = '".$journal->users['id']."'";
			$user_link = "user=".$journal->users['id']."&amp;";
		}
		else
		{
			// -----------------------------------
			// Make main query
			// -----------------------------------
			if ($ibforums->member['g_j_modview'])
			{
				$q_extra = "";
			}
			else
			{
				if ($ibforums->member['id'] == 0)
				{
					// show only public non blocked journal for quest
					$q_extra = " AND me.j_blocked <> 1 AND me.j_public = 1";
				}
				else
				{
					if ($ufriends != "")
					{
						$q_extra = " AND me.j_blocked <> 1 AND (me.j_public = 1 OR me.j_public = 3 OR (me.j_public = 2 AND p.journal_id IN(".$ufriends.")))";
					}
					else
					{
						$q_extra = " AND me.j_blocked <> 1 AND (me.j_public = 1 OR me.j_public = 3)";
					}
				}
			}
		}

		// -----------------------------------
		// Make page jump links
		// -----------------------------------
		$DB->query("SELECT p.journal_id, me.j_public
					FROM ibf_jposts p
					LEFT JOIN ibf_member_extra me ON (me.id=p.journal_id)
					WHERE p.post_date > '".$db_start_date."'
					AND p.post_date < '".$db_end_date."'".$q_extra);

		$max = $DB->get_num_rows();
		$DB->free_result();

		$first = 0;
		if (isset($ibforums->input['st'])) $first = intval($ibforums->input['st']);
		if ($first >= $max) $first = (floor($max / 15) * 15);
		if ($first < 0) $first = 0;

		$page_info = $this->html->j_pages($journal->build_pagelinks( array( 'TOTAL_POSS'  => $max,
											'PER_PAGE'    => 15,
											'CUR_ST_VAL'  => $first,
											'L_SINGLE'    => "",
											'BASE_URL'    => $journal->base_url.$user_link."list=allpost&amp;year=".$sel_year."&amp;mon=".$sel_mon."&amp;day=".$sel_day."&amp;days=".$days,
										  )));

		// -----------------------------------
		// Show posts
		// -----------------------------------

		$html = $page_info;
		$DB->query("SELECT p.*, me.j_public, me.id, m.name
					FROM ibf_jposts p
					LEFT JOIN ibf_member_extra me ON (me.id=p.journal_id)
					LEFT JOIN ibf_members m ON (m.id=p.journal_id)
					WHERE p.post_date > '".$db_start_date."'
					AND p.post_date < '".$db_end_date."'".$q_extra."
					ORDER BY p.post_date DESC LIMIT ".$first.",15");

		if ($DB->get_num_rows())
		{
			$old_date = "";
			$start_post = true;
			while ($r = $DB->fetch_row())
			{
				$r['time'] = $journal->get_date($r['post_date'],"H:i");
				$r['date'] = $journal->get_date($r['post_date'],"d F Y");

				if ($old_date != $r['date'])
				{
					if (!$start_post)
					{
						$html .= $this->html->j_post_bottom();
					}
					$html .= $this->html->j_post_top($r['date']);
				}

				if ($r['author_id'] == $r['id']) $r['author_name'] = $r['name'];
				$r['post_member'] = "{$ibforums->lang['j_journal']}: <a style='text-decoration:none' href='".$journal->base_url."user=".$r['id']."' title='".$ibforums->lang['j_tips_journal']."'><b>{$r['author_name']}</b></a> -";

				// show closed ?
				if ($r['closed'] == 1 and !($ibforums->member['g_j_modview'] or ($r['id'] == $ibforums->member['id']) or (in_array($r['id'],$ufriend))))
				{
					$html .= $this->html->j_post_closed($r);
				}
				else
				{
					// word wrap
					if ($ibforums->vars['post_wordwrap'] > 0)
					{
						$r['post'] = preg_replace("#([^\s<>'\"/\.\\-\?&\n\r\%]{".$ibforums->vars['post_wordwrap']."})#i", " \\1<br />" ,$r['post']);
					}

					// get attachments as link
					if ($r['attach_id'])
					{
						$r['attachment'] = "<br />".$ibforums->lang['j_image']." <a href='".$ibforums->vars['j_upload_url']."/".$r['attach_id']."' target='_blank'>".$ibforums->vars['j_upload_url']."/".$r['attach_id']."</a><br />";
					}

					// replace <br> with <br /> (XHTML)
					$r['post'] = str_replace("<br>","<br />",$r['post']);

					// show post
					$html .= $this->html->j_post($r);
				}
				$old_date = $r['date'];
				$start_post = false;
			}
		}
		else
		{
			$html .= $this->html->j_post_top($journal->get_date($db_start_date,"d F Y"));
			$html .= $this->html->j_post_no();
		}

		$html .= $this->html->j_post_bottom();
		$html .= $page_info;

		$journal->nav[] = "<a href='".$journal->base_url.$user_link."list=calendar&amp;year=".$sel_year."&amp;mon=".$sel_mon."'>".$ibforums->lang['j_calendar_list']."</a>";

		if ($days > 0)
		{
			$journal->nav[] = $ibforums->lang['j_cal_rec_from'].$journal->get_date($db_start_date,"d F Y").$ibforums->lang['j_cal_to'].$journal->get_date($db_end_date,"d F Y");
		}
		else
		{
			$journal->nav[] = $ibforums->lang['j_cal_rec_at'].$journal->get_date($db_start_date,"d F Y");
		}
		return $html;
	}




	// show all comments in selected days
	function show_comm()
	{
		global $ibforums, $DB, $journal;

		// -----------------------------------
		// Make date
		// -----------------------------------

		// save offset
		$offset = $journal->get_time_offset();

		// get selected mon, year and day
		list($cur_day, $cur_mon, $cur_year) = explode(",",gmdate( 'j,n,Y', time() + $offset));

		$sel_mon = (!intval($ibforums->input['mon'])) ? $cur_mon : intval($ibforums->input['mon']);
		$sel_year  = (!intval($ibforums->input['year'])) ? $cur_year : intval($ibforums->input['year']);
		$sel_day  = (!intval($ibforums->input['day'])) ? $cur_day : intval($ibforums->input['day']);

		if (!checkdate($sel_mon, $sel_day , $sel_year))
		{
			$sel_mon = $cur_mon;
			$sel_year = $cur_year;
			$sel_day = $cur_day;
		}
		// difference betwen local time and user time
		$diff_date = mktime(0,0,0,1,1,1999) - (gmmktime(0,0,0,1,1,1999) - $offset);

		// make start of this day
		$db_start_date = mktime(0,0,0,$sel_mon,$sel_day,$sel_year) - $diff_date;

		// make end of this day
		$db_end_date = mktime(23,59,59,$sel_mon,$sel_day,$sel_year) - $diff_date;


		if (isset($ibforums->input['days']) and intval($ibforums->input['days']) > 1)
		{
            $days = intval($ibforums->input['days']);
			if ($days > 10) $days = 10;

			$db_start_date = $db_end_date - (86400 * $days) + 1;
		}

		// -----------------------------------
		// Cache ufriends
		// -----------------------------------

		$ufriends = "";
		$ufriend = array();
		// is a member ?
		if ($ibforums->member['id'])
		{
			// yes. cache ufriends
			$DB->query("SELECT member_id FROM ibf_jfriends WHERE friend_id='".$ibforums->member['id']."'");
			while ($r = $DB->fetch_row())
			{
				$ufriend[$r['member_id']] = $r['member_id'];
			}
			if (count($ufriend) > 0) $ufriends = implode(",",$ufriend);
		}

		$html = "";
		$user_link = "";

		if ($journal->users['id'])
		{
			// make user journal query
			$q_extra = " AND p.journal_id = '".$journal->users['id']."'";
			$user_link = "user=".$journal->users['id']."&amp;";
		}
		else
		{
			// -----------------------------------
			// Make main query
			// -----------------------------------
			if ($ibforums->member['g_j_modview'])
			{
				$q_extra = "";
			}
			else
			{
				if ($ibforums->member['id'] == 0)
				{
					// show only public non blocked journal for quest
					$q_extra = " AND me.j_blocked <> 1 AND me.j_public = 1";
				}
				else
				{
					if ($ufriends != "")
					{
						$q_extra = " AND me.j_blocked <> 1 AND (me.j_public = 1 OR me.j_public = 3 OR (me.j_public = 2 AND p.journal_id IN(".$ufriends.")))";
					}
					else
					{
						$q_extra = " AND me.j_blocked <> 1 AND (me.j_public = 1 OR me.j_public = 3)";
					}
				}
			}
		}
		// -----------------------------------
		// Make page jump links
		// -----------------------------------

		$DB->query("SELECT c.owner_id, p.journal_id, me.j_public
					FROM ibf_jcomments c
					LEFT JOIN ibf_jposts p ON (p.pid=c.post_id)
					LEFT JOIN ibf_member_extra me ON (me.id=c.owner_id)
					WHERE c.post_date > '".$db_start_date."'
					AND c.post_date < '".$db_end_date."'".$q_extra);

		$max = $DB->get_num_rows();
		$DB->free_result();

		$first = 0;
		if (isset($ibforums->input['st'])) $first = intval($ibforums->input['st']);
		if ($first >= $max) $first = (floor($max / 15) * 15);
		if ($first < 0) $first = 0;

		$page_info = $this->html->j_pages($journal->build_pagelinks( array( 'TOTAL_POSS'  => $max,
											'PER_PAGE'    => 15,
											'CUR_ST_VAL'  => $first,
											'L_SINGLE'    => "",
											'BASE_URL'    => $journal->base_url.$user_link."list=allcomm&amp;year=".$sel_year."&amp;mon=".$sel_mon."&amp;day=".$sel_day."&amp;days=".$days,
										  )));

		// -----------------------------------
		// Show comments
		// -----------------------------------

		$html = $page_info;

		$DB->query("SELECT c.*, p.pid, p.title, p.closed, p.comments, me.j_public, me.id, m.name
					FROM ibf_jcomments c, ibf_jposts p
					LEFT JOIN ibf_member_extra me ON (me.id=c.owner_id)
					LEFT JOIN ibf_members m ON (m.id=c.owner_id)
					WHERE c.post_date > '".$db_start_date."'
					AND p.pid = c.post_id
					AND c.post_date < '".$db_end_date."'".$q_extra."
					ORDER BY c.post_date DESC LIMIT ".$first.",15");

		if ($DB->get_num_rows())
		{
			$old_date = "";
			$start_post = true;
			while ($r = $DB->fetch_row())
			{
				$r['time'] = $journal->get_date($r['post_date'],"H:i");
				$r['date'] = $journal->get_date($r['post_date'],"d F Y");

				if ($old_date != $r['date'])
				{
					if (!$start_post)
					{
						$html .= $this->html->j_post_bottom();
					}
					$html .= $this->html->j_post_top($r['date']);
				}

				$r['post_member'] = "{$ibforums->lang['j_journal']}: <a style='text-decoration:none' href='".$journal->base_url."user=".$r['id']."' title='".$ibforums->lang['j_tips_journal']."'><b>{$r['name']}</b></a> -";

				// show closed ?
				if ($r['closed'] == 1 and !($ibforums->member['g_j_modview'] or ($r['id'] == $ibforums->member['id']) or (in_array($r['id'],$ufriend))))
				{
					$html .= $this->html->j_post_closed($r);
				}
				else
				{
					$r['journal'] = "{$ibforums->lang['j_journal']}: <a style='text-decoration:none' href='".$journal->base_url."user=".$r['id']."' title='".$ibforums->lang['j_tips_journal']."'><b>".$r['name']."</b></a>";

					if ($r['author_id'] > 0)
					{
						$r['author'] = "<a style='text-decoration:none' href='".$ibforums->base_url."showuser=".$r['author_id']."'>".$r['author_name']."</a>";
					}
					else
					{
						$r['author'] = "<span style='color:AA3300'>".$r['author_name']."</span>";
					}

					// word wrap
					if ($ibforums->vars['post_wordwrap'] > 0)
					{
						$r['post'] = preg_replace("#([^\s<>'\"/\.\\-\?&\n\r\%]{".$ibforums->vars['post_wordwrap']."})#i", " \\1<br />" ,$r['post']);
					}

					// get attachments as link
					if ($r['attach_id'])
					{
						$r['attachment'] = "<br />".$ibforums->lang['j_image']." <a href='".$ibforums->vars['j_upload_url']."/".$r['attach_id']."' target='_blank'>".$ibforums->vars['j_upload_url']."/".$r['attach_id']."</a><br />";
					}

					// replace <br> with <br /> (XHTML)
					$r['post'] = str_replace("<br>","<br />",$r['post']);

					// show post
					$html .= $this->html->j_comment($r);
				}
				$old_date = $r['date'];
				$start_post = false;
			}
		}
		else
		{
			$html .= $this->html->j_post_top($journal->get_date($db_start_date,"d F Y"));
			$html .= $this->html->j_post_no();
		}

		$html .= $this->html->j_post_bottom();
		$html .= $page_info;

		$journal->nav[] = "<a href='".$journal->base_url.$user_link."list=calendar&amp;year=".$sel_year."&amp;mon=".$sel_mon."'>".$ibforums->lang['j_calendar_list']."</a>";

		if ($days > 0)
		{
			$journal->nav[] = $ibforums->lang['j_cal_comm_from'].$journal->get_date($db_start_date,"d F Y").$ibforums->lang['j_cal_to'].$journal->get_date($db_end_date,"d F Y");
		}
		else
		{
			$journal->nav[] = $ibforums->lang['j_cal_comm_at'].$journal->get_date($db_start_date,"d F Y");
		}
		return $html;
	}



}
?>