<?php


class journal_info {

	var $users     = array();
	var $friends   = array();
	var $out_data  = array();
	var $output    = "";
	var $nav       = "";
	var $base_url  = "";
	var $html      = "";
	var $title     = "";
	var $skin_set  = "";
	var $readed    = array();
	var $offset_set = 0;
	var $offset    = 0;

	function journal_info ()
	{
		global $ibforums, $std, $DB;

		// make url
		$this->base_url = $ibforums->vars['board_url'].'/journal.'.$ibforums->vars['php_ext'].'?';

		// loading lang
		$ibforums->lang = $std->load_words($ibforums->lang, 'lang_journal', $ibforums->lang_id);

		// make def. navigation link
		$this->nav = array ("<a href='{$ibforums->base_url}'>{$ibforums->lang['j_board_name']}</a>","<a href='".$this->base_url."'>".$ibforums->lang['j_title']."</a>");

		// loading default skin css
		$DB->query("SELECT skin_css FROM ibf_jskins WHERE sid='".$ibforums->vars['j_def_skin']."'");
		$row = $DB->fetch_row();
		$this->skin_set = $row['skin_css'];

		// get user info
		if (preg_match("/^\d+$/",$ibforums->input['user']))
		{
			// Get user info from database
			$DB->query("SELECT m.id, m.hide_email, m.website, m.icq_number, m.joined, m.name, me.id as me_id,
						me.j_photo_dim, me.j_photo, me.j_photo_type, me.j_view_prefs, me.j_public, me.j_posts, me.j_comments, me.j_title, me.j_edit_comment,
						me.j_del_comment, me.j_add_comment, me.j_last_post, me.j_last_comment, me.j_info_pos, me.j_show_friends, me.j_show_thumb,
						me.j_th_width, me.j_th_height, me.j_auto_mail, me.j_block_friends, me.j_block_ufriends, me.j_block_favorite,
						me.j_block_ufavorite, me.j_block_calendar, me.j_block_comments, me.j_show_img, me.j_allow_upload, me.j_allow_codes, me.j_blocked,
						me.j_skin_css, me.j_friend_access, me.j_votes, me.j_block_votes,
						g.g_id, g.g_title as group_title, g.g_j_own_journal, g.g_j_design
						FROM ibf_members m
						LEFT JOIN ibf_groups g ON (g.g_id=m.mgroup)
						LEFT JOIN ibf_member_extra me ON (me.id=m.id)
						WHERE m.id='".$ibforums->input['user']."'");
			$this->users = $DB->fetch_row();

			// if member_extra is not set for this user (no posts, no setting changed, first run, e.t.c)
			// set default
			if ($this->users['id'] and !$this->users['me_id']) $this->set_default();
		}

		// update statistic
		$this->update_stats();
	}


	function initialize()
	{
		global $ibforums, $DB;

        // loading skin
		$this->html = $this->load_template('skin_jinfo');

		// set default css
		if ($this->skin_set == "") $this->skin_set = $this->html->j_def_css();

		// don't show journals for this member group ?
		if (!$ibforums->member['g_j_showhim'])
		{
			$this->err_journal($ibforums->lang['j_err_no_access']);
		}

		// if user present
		if ($this->users['id'])
		{
			// journal is blocked and no moderator ?
			if ($this->users['j_blocked'] and !$ibforums->member['g_j_modview'])
			{
				$this->err_journal($ibforums->lang['j_err_blocked']);
			}

			// disabled journals for this member group ?
			if (!$this->users['g_j_own_journal'])
			{
				$this->err_journal($ibforums->lang['j_err_no_own']);
			}

			// cache him friends
			$this->cache_friends();

			// check access
			if (!$this->check_access())
			{
				$this->err_journal($ibforums->lang['j_err_closed']);
			}

			$this->set_access();
			$this->make_user_info();
			return true;
		}
		else
		{
			if (isset($ibforums->input['user']))
			{
				$this->err_journal($ibforums->lang['j_err_no_user']);
			}
			return false;
		}
	}


	function update_stats()
	{
		global $ibforums, $DB, $HTTP_SERVER_VARS;

		// calculate statistics if enabled and if graf counter is disabled
		if ($ibforums->vars['j_stat_counter'] and !$ibforums->vars['j_graph_counter'])
		{
			// initialize
			$day = gmdate("dmY");
			$add_hosts = 0;

			// get data info
			$DB->query("SELECT id FROM ibf_jstats WHERE id=0 AND t_date='".$day."'");
			if (!$DB->get_num_rows())
			{
				// clear all statistics. new day
				$DB->query("DELETE FROM ibf_jstatuid");
				$DB->query("DELETE FROM ibf_jstatip");
				$DB->query("UPDATE ibf_jstats SET t_users=0, t_hosts=0, t_hits=0, t_date='".$day."'");
			}

			// get stats info
			$DB->query("SELECT id, hits, t_hits, hosts, t_hosts, users, t_users
						FROM ibf_jstats
						WHERE id='".$this->users['id']."'");

			$users = $DB->fetch_row();

			// user found and no stat info found. must add stat info
			if ($this->users['id'] and !$users['id'])
			{
				$DB->query("INSERT INTO ibf_jstats SET id='".$this->users['id']."', t_date='".$day."'");
				$users['id'] = $this->users['id'];
			}
			// no user found. use as global info
			else if (!$this->users['id'])
			{
				$users['id'] = 0;
			}


			// get ip
			if (!empty($HTTP_SERVER_VARS["HTTP_X_FORWARDED_FOR"])) $ip = $HTTP_SERVER_VARS["HTTP_X_FORWARDED_FOR"];
			else $ip = $HTTP_SERVER_VARS["REMOTE_ADDR"];
			if (($pos = strrpos($ip,",")) != 0) $ip = trim(substr($ip,$pos+1));
			$ip = ip2long($ip);


			// update global statistics
			if ($users['id'] > 0)
			{
				$g_hosts = 0;

				// ip is already in database ?
				$DB->query("SELECT ip FROM ibf_jstatip WHERE ip='".$ip."' LIMIT 1");
				if (!$DB->get_num_rows()) $g_hosts = 1;

				// update global statistics info
				$DB->query("UPDATE ibf_jstats
							SET hosts = hosts + '".$g_hosts."',
								t_hosts = t_hosts + '".$g_hosts."',
								t_hits = t_hits + '1',
								hits = hits + '1' WHERE id='0'");
			}

			// get ip from database and check hosts
			$DB->query("SELECT ip FROM ibf_jstatip WHERE ip='".$ip."' AND journals='".$users['id']."' LIMIT 1");
			// present in database ?
			if (!$DB->get_num_rows())
			{
				// no. must add
				$DB->query("INSERT INTO ibf_jstatip SET ip='".$ip."', journals='".$users['id']."'");
				$add_hosts++;
				$users['t_hosts'] ++;
				$users['hosts'] ++;
			}

			// save statistics info
			$DB->query("UPDATE ibf_jstats
						SET hosts = hosts + '".$add_hosts."',
							t_hosts = t_hosts + '".$add_hosts."',
							t_hits = t_hits + '1',
							hits = hits + '1' WHERE id='".$users['id']."'");
			// add hits
			$users['t_hits'] ++;
			$users['hits'] ++;
			$this->users['hosts'] = $users['hosts'];
			$this->users['t_hosts'] = $users['t_hosts'];
			$this->users['hits'] = $users['hits'];
			$this->users['t_hits'] = $users['t_hits'];
		}
	}


	function output()
	{
		global $ibforums, $DB, $Debug, $print;

		// get member bar
		if ($ibforums->member['id'])
		{
			$bar = $this->html->j_member_bar();
		}
		else
		{
			$bar = $this->html->j_guest_bar();
		}

		$template = $this->html->j_html($this->title.$ibforums->lang['j_title']." :: ".$ibforums->vars['board_name'],$this->skin_set);

		$template = str_replace("<!--IBJ.USERBAR-->",$bar,$template);
		$template = str_replace("<!--IBJ.NAV-->",implode(" -&gt; ",$this->nav),$template);
		$template = str_replace("<!--IBJ.MAIN-->",$this->output,$template);


		// *******************************
		// DEBUG
		// *******************************
        $gzip_status = $ibforums->vars['disable_gzip'] == 1 ? $ibforums->lang['gzip_off'] : $ibforums->lang['gzip_on'];

        if ($ibforums->server_load > 0)
        {
        	$sload = '&nbsp; [ Server Load: '.$ibforums->server_load.' ]';
        }

        if ($ibforums->vars['debug_level'] > 0)
        {
			$stats = "<div align='center' class='copyright'>[ Script Execution time: ".sprintf( "%.4f",$Debug->endTimer())." ] &nbsp; [ ".$DB->get_query_cnt()." queries used ] &nbsp; [ $gzip_status ] $sload</div>";
        }

		if ($ibforums->vars['debug_level'] >= 2)
		{
			$stats .= "<br />\n<div class='tableborder'>\n<div class='infhead1' align='left'>FORM and GET Input</div><div class='inftext1' style='padding:6px' align='left'>\n";

			while( list($k, $v) = each($ibforums->input) )
			{
				$stats .= "<strong>$k</strong> = $v<br />\n";
			}

			$stats .= "</div>\n</div>";
        }

        if ($ibforums->vars['debug_level'] >= 3)
        {
           	$stats .= "<br />\n<div class='tableborder'>\n<div class='infhead1' align='left'>Queries Used</div><div class='inftext1' style='padding:6px' align='left'>";

        	foreach($DB->obj['cached_queries'] as $q)
        	{
        		$q = htmlspecialchars($q);
        		$q = preg_replace( "/^SELECT/i" , "<span style='color:red'>SELECT</span>"   , $q );
        		$q = preg_replace( "/^UPDATE/i" , "<span style='color:blue'>UPDATE</span>"  , $q );
        		$q = preg_replace( "/^DELETE/i" , "<span style='color:orange'>DELETE</span>", $q );
        		$q = preg_replace( "/^INSERT/i" , "<span style='color:green'>INSERT</span>" , $q );
        		$q = str_replace( "LEFT JOIN"   , "<span style='color:red'>LEFT JOIN</span>" , $q );

        		$q = preg_replace( "/(".$ibforums->vars['sql_tbl_prefix'].")(\S+?)([\s\.,]|$)/", "<span style='color:purple'>\\1\\2</span>\\3", $q );

        		$stats .= "$q<hr />\n";
        	}
        	$stats .= "</div>\n</div>";
        }

		if ($ibforums->vars['debug_level'])
		{
			$template = str_replace("<!--IBJ.DEBUG-->", "<tr><td>".$stats."</td></tr>", $template);
		}
		// *******************************
		// END DEBUG
		// *******************************


		// *******************************
		// Copyright
		// *******************************
		// Invision copyright
		// DONT REMOVE THIS !!!
		// *******************************
        $extra = "";
        $ur    = '(U)';

        if ( $ibforums->vars['ipb_reg_number'] )
        {
        	$ur = '(R)';

        	if ( $ibforums->vars['ipb_reg_show'] and $ibforums->vars['ipb_reg_name'] )
        	{
        		$extra = "<div align='center' class='copyright'>Registered to: ". $ibforums->vars['ipb_reg_name']."</div>";
        	}
        }

        $copyright = "<div align='center' class='copyright'>Powered by <a href=\"http://www.invisionboard.com\" target='_blank'>Invision Power Board</a>{$ur} &copy; 2003 &nbsp;<a href='http://www.invisionpower.com' target='_blank'>IPS, Inc.</a></div>";

        if ($ibforums->vars['ips_cp_purchase'])
        {
        	$copyright = "";
        }
        $copyright .= $extra;

		$template = str_replace( "<!--IBJ.COPYRIGHT-->", "<tr><td>".$copyright."</td></tr>", $template );

		// *******************************
		// END Copyright
		// *******************************


		// Close this DB connection
		$DB->close_db();

		// Start GZIP compression
        if ($ibforums->vars['disable_gzip'] != 1)
        {
        	$buffer = ob_get_contents();
        	ob_end_clean();
        	ob_start('ob_gzhandler');
        	print $buffer;
        }

        $print->do_headers();
		print $template;
		exit();
	}


	function make_output()
	{
		global $ibforums;

		$info = $this->html->j_template_info($this->out_data);
		$posts = $this->html->j_template_posts($this->out_data);
		if ($this->users['j_info_pos'] != 0)
		{
			$this->output = $this->html->j_template($this->out_data['page_title'],$info,$posts);
		}
		else
		{
			$this->output = $this->html->j_template($this->out_data['page_title'],$posts,$info);
		}
		if (isset($this->users['j_skin_css']) and $this->users['j_skin_css'] != "") $this->skin_set = $this->users['j_skin_css'];
	}


	function set_default()
	{
		global $ibforums, $DB;
		$def_array = array( 'id' => $this->users['id'], 'j_photo_dim' => null, 'j_photo' => null, 'j_photo_type' => null,
							'j_view_prefs' => '-1&-1', 'j_public' => 0, 'j_posts' => 0,
							'j_comments' => 0, 'j_title' => null, 'j_edit_comment' => 1,
							'j_del_comment' => 1, 'j_add_comment' => 1, 'j_last_post' => 0,
							'j_last_comment' => 0, 'j_info_pos' => 0, 'j_show_friends' => 1,
							'j_show_thumb' => 1, 'j_th_width' => 500, 'j_th_height' => 500,
							'j_auto_mail' => 0, 'j_block_friends' => 2, 'j_block_ufriends' => 2,
							'j_block_favorite' => 2, 'j_block_ufavorite' => 2, 'j_block_calendar' => 2,
							'j_block_comments' => 1, 'j_show_img' => 1, 'j_allow_upload' => 1, 'j_allow_codes' => 1,
							'j_blocked' => 0, 'j_friend_access' => 0, 'j_skin_css' => '', 'j_votes' => '', 'j_block_votes' => 1);
		// add to database
		$db_string = $DB->compile_db_insert_string($def_array);
		$DB->query("INSERT INTO ibf_member_extra (" .$db_string['FIELD_NAMES']. ") VALUES (". $db_string['FIELD_VALUES'] .")");

		$this->users = array_merge($this->users,$def_array);
	}

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Access functions
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	// Check access
	function check_access()
	{
		global $ibforums;

		// is a moderator
		if ($ibforums->member['g_j_modview']) return TRUE;

		// is a owner
		if ($this->users['id'] == $ibforums->member['id']) return TRUE;

		// closed journal ?
		if ($this->users['j_public'] == 0) return FALSE;

		// show friends only ?
		if ($this->users['j_public'] == 2 and !$ibforums->member['is_friend']) return FALSE;

		// show guest ?
		if ($this->users['j_public'] == 3 and ($ibforums->member['id'] == 0)) return FALSE;

		return TRUE;
	}

	// set access
	function set_access()
	{
		global $ibforums;

		if ($ibforums->member['g_j_modview'] or ($this->users['id'] == $ibforums->member['id']) or $ibforums->member['is_friend'])
		{
			$ibforums->member['j_view'] = 1;
		}
		if (($ibforums->member['id'] == $this->users['id']) or $ibforums->member['g_j_modview'] or ($this->users['j_friend_access'] and $ibforums->member['is_friend']))
		{
			$ibforums->member['j_edit'] = 1;
		}
	}





// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	// Journal error
	function err_journal($data)
	{
		global $ibforums;

		$this->title = $ibforums->lang['j_err_title']." :: ";
		$this->nav[] = $ibforums->lang['j_err_title'];
		$this->output = $this->html->j_error($data);

		$this->output();
		exit();
	}



// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// IPB 1.2 code (for compatibility with other version and work this skin)
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    function redirect_screen($text="", $url="")
    {
    	global $ibforums, $DB, $print;

		if ($ibforums->input['debug'])
		{
			flush();
			exit();
		}

		$ibforums->lang['stand_by'] = stripslashes($ibforums->lang['stand_by']);

		$htm = $this->html->j_redirect($text, $url, $this->skin_set);

		// Close this DB connection
		$DB->close_db();

		// Start GZIP compression
		if ($ibforums->vars['disable_gzip'] != 1)
		{
			$buffer = ob_get_contents();
			ob_end_clean();
			ob_start('ob_gzhandler');
			print $buffer;
		}
		$print->do_headers();
		echo ($htm);
		exit;
    }


	function build_pagelinks($data)
	{
		global $ibforums;

		$work = array();

		$section = ($data['leave_out'] == "") ? 2 : $data['leave_out'];  // Number of pages to show per section( either side of current), IE: 1 ... 4 5 [6] 7 8 ... 10

		$work['pages']  = 1;

		if ( ($data['TOTAL_POSS'] % $data['PER_PAGE']) == 0 )
		{
			$work['pages'] = $data['TOTAL_POSS'] / $data['PER_PAGE'];
		}
		else
		{
			$number = ($data['TOTAL_POSS'] / $data['PER_PAGE']);
			$work['pages'] = ceil( $number);
		}


		$work['total_page']   = $work['pages'];
		$work['current_page'] = $data['CUR_ST_VAL'] > 0 ? ($data['CUR_ST_VAL'] / $data['PER_PAGE']) + 1 : 1;


		if ($work['pages'] > 1)
		{
			$work['first_page'] = $this->html->make_page_jump($data['TOTAL_POSS'],$data['PER_PAGE'], $data['BASE_URL'])." (".$work['pages'].")";

			for( $i = 0; $i <= $work['pages'] - 1; ++$i )
			{
				$RealNo = $i * $data['PER_PAGE'];
				$PageNo = $i+1;

				if ($RealNo == $data['CUR_ST_VAL'])
				{
					$work['page_span'] .= "&nbsp;<b>[{$PageNo}]</b>";
				}
				else
				{

					if ($PageNo < ($work['current_page'] - $section))
					{
						$work['st_dots'] = "&nbsp;<a href='{$data['BASE_URL']}&amp;st=0' title='{$ibforums->lang['ps_page']} 1'>&laquo; {$ibforums->lang['ps_first']}</a>&nbsp;...";
						continue;
					}

					// If the next page is out of our section range, add some dotty dots!

					if ($PageNo > ($work['current_page'] + $section))
					{
						$work['end_dots'] = "...&nbsp;<a href='{$data['BASE_URL']}&amp;st=".($work['pages']-1) * $data['PER_PAGE']."' title='{$ibforums->lang['ps_page']} {$work['pages']}'>{$ibforums->lang['ps_last']} &raquo;</a>";
						break;
					}


					$work['page_span'] .= "&nbsp;<a href='{$data['BASE_URL']}&amp;st={$RealNo}'>{$PageNo}</a>";
				}
			}

			$work['return']    = $work['first_page'].$work['st_dots'].$work['page_span'].'&nbsp;'.$work['end_dots'];
		}
		else
		{
			$work['return']    = $data['L_SINGLE'];
		}

		return $work['return'];
	}

	function return_md5_check()
	{
		global $ibforums;

		if ( $ibforums->member['id'] )
		{
			return md5($ibforums->member['email'].'&'.$ibforums->member['password'].'&'.$ibforums->member['joined']);
		}
		else
		{
			return md5("this is only here to prevent it breaking on guests");
		}
	}


	function load_template($name)
	{
		require ROOT_PATH."sources/journal/$name.php";
		return new $name();
	}

	function get_time_offset()
	{
		global $ibforums;

		if ($this->offset_set == 0)
		{
        	// Save redoing this code for each call, only do once per page load

			$this->offset = (($ibforums->member['time_offset'] != "") ? $ibforums->member['time_offset'] : $ibforums->vars['time_offset']) * 3600;

			if ($ibforums->vars['time_adjust'] != "" and $ibforums->vars['time_adjust'] != 0)
			{
				$this->offset += ($ibforums->vars['time_adjust'] * 60);
			}

			if ($ibforums->member['dst_in_use'])
			{
				$this->offset += 3600;
			}

			$this->offset_set = 1;
		}
		return $this->offset;
	}


	function scale_image($arg)
	{
		// max_width, max_height, cur_width, cur_height

		$ret = array(
					  'img_width'  => $arg['cur_width'],
					  'img_height' => $arg['cur_height']
					);

		if ( $arg['cur_width'] > $arg['max_width'] )
		{
			$ret['img_width']  = $arg['max_width'];
			$ret['img_height'] = ceil( ( $arg['cur_height'] * ( ( $arg['max_width'] * 100 ) / $arg['cur_width'] ) ) / 100 );
			$arg['cur_height'] = $ret['img_height'];
			$arg['cur_width']  = $ret['img_width'];
		}

		if ( $arg['cur_height'] > $arg['max_height'] )
		{
			$ret['img_height']  = $arg['max_height'];
			$ret['img_width']   = ceil( ( $arg['cur_width'] * ( ( $arg['max_height'] * 100 ) / $arg['cur_height'] ) ) / 100 );
		}


		return $ret;

	}




// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	// Make rus date
	function get_date($data,$format="")
	{
		global $ibforums;

		if ($format != "")
		{
			$trans = array( "Jan" => $ibforums->lang['j_jan'],
							"Feb" => $ibforums->lang['j_feb'],
							"Mar" => $ibforums->lang['j_mar'],
							"Apr" => $ibforums->lang['j_apr'],
							"May" => $ibforums->lang['j_may'],
							"Jun" => $ibforums->lang['j_jun'],
							"Jul" => $ibforums->lang['j_jul'],
							"Aug" => $ibforums->lang['j_aug'],
							"Sep" => $ibforums->lang['j_sep'],
							"Oct" => $ibforums->lang['j_oct'],
							"Nov" => $ibforums->lang['j_nov'],
							"Dec" => $ibforums->lang['j_dec'],
							"January" => $ibforums->lang['j_january'],
							"February" => $ibforums->lang['j_february'],
							"March" => $ibforums->lang['j_march'],
							"April" => $ibforums->lang['j_april'],
							"May" => $ibforums->lang['j_may2'],
							"June" => $ibforums->lang['j_june'],
							"July" => $ibforums->lang['j_july'],
							"August" => $ibforums->lang['j_august'],
							"September" => $ibforums->lang['j_september'],
							"October" => $ibforums->lang['j_october'],
							"November" => $ibforums->lang['j_november'],
							"December" => $ibforums->lang['j_december'],
							"Sun" => $ibforums->lang['j_sun'],
							"Mon" => $ibforums->lang['j_mon'],
							"Tue" => $ibforums->lang['j_tue'],
							"Wed" => $ibforums->lang['j_wed'],
							"Thu" => $ibforums->lang['j_thu'],
							"Fri" => $ibforums->lang['j_fri'],
							"Sat" => $ibforums->lang['j_sat'],
							"Sunday" => $ibforums->lang['j_sunday'],
							"Monday" => $ibforums->lang['j_monday'],
							"Tuesday" => $ibforums->lang['j_tuesday'],
							"Wednesday" => $ibforums->lang['j_wednesday'],
							"Thursday" => $ibforums->lang['j_thursday'],
							"Friday" => $ibforums->lang['j_friday'],
							"Saturday" => $ibforums->lang['j_saturday']);

			return strtr(gmdate($format,$data + $this->get_time_offset()),$trans);
		}
		else
		{
			if (!$data) return 0;

			$offset = $this->get_time_offset();
			$data += $offset;

			$d_date = gmdate("d.m.Y",$data);
			$d_time = gmdate("H:i",$data);
			if ($d_date == gmdate("d.m.Y",time() + $offset))
			{
				return $ibforums->lang['j_today']." ".$d_time;
			}
			elseif ($d_date == gmdate("d.m.Y",time() + $offset - 86400))
			{
				return $ibforums->lang['j_yesterday']." ".$d_time;
			}
			else
			{
				return $d_date." ".$d_time;
			}
		}
	}

	// Check post tracker
	function check_post_tracker($pid)
	{
		global $ibforums, $DB;

		if ($ibforums->member['id'] and $ibforums->input['enabletrack'] == 1)
		{
			$DB->query("SELECT trid FROM ibf_jtracker WHERE post_id='".$pid."' AND member_id='".$ibforums->member['id']."'");
			if (!$DB->get_num_rows())
			{
				$db_string = $DB->compile_db_insert_string(array(
																	'member_id'  => $ibforums->member['id'],
																	'post_id'   => $pid,
																	'start_date' => time(),
														  ));
				$DB->query("INSERT INTO ibf_jtracker ({$db_string['FIELD_NAMES']}) VALUES ({$db_string['FIELD_VALUES']})");
			}
		}
		if ($ibforums->member['id'] and $ibforums->input['disabletrack'] == 1)
		{
			$DB->query("DELETE FROM ibf_jtracker WHERE member_id='".$ibforums->member['id']."' AND post_id='".$pid."'");
		}
	}

	// delete uploaded attached file
	function del_uploaded($attach_id)
	{
		global $ibforums;

		if (@file_exists($ibforums->vars['j_upload_dir']."/".$attach_id))
		{
			@unlink($ibforums->vars['j_upload_dir']."/".$attach_id);
		}
	}

	// Upload file
	function process_upload()
	{
		global $ibforums, $HTTP_POST_FILES, $FILE_UPLOAD;

		// Set up some variables to stop carpals developing
		$FILE_NAME = $HTTP_POST_FILES['FILE_UPLOAD']['name'];
		$FILE_SIZE = $HTTP_POST_FILES['FILE_UPLOAD']['size'];
		$FILE_TYPE = $HTTP_POST_FILES['FILE_UPLOAD']['type'];

		// Naughty Opera adds the filename on the end of the
		// mime type - we don't want this.
		$FILE_TYPE = preg_replace( "/^(.+?);.*$/", "\\1", $FILE_TYPE );

		// Return if we don't have a file to upload
		//-------------------------------------------------
		// Naughty Mozilla likes to use "none" to indicate an empty upload field.
		// I love universal languages that aren't universal.
		if ($HTTP_POST_FILES['FILE_UPLOAD']['name'] == "" or !$HTTP_POST_FILES['FILE_UPLOAD']['name'] or ($HTTP_POST_FILES['FILE_UPLOAD']['name'] == "none") ) return "";

		// Check the file size
		if ($FILE_SIZE > ($ibforums->vars['j_attach_max']*1024))
		{
			$this->err_journal($ibforums->lang['j_err_dl_big']);
		}

		// Check image by mime
		$mime_allowed = array ( "image/x-png" => ".png",
								"image/png" => ".png",
								"image/gif" => ".gif",
								"image/jpeg" => ".jpg",
								"image/pjpeg" => ".jpg");

		if(!isset($mime_allowed[$FILE_TYPE]))
		{
			$this->err_journal($ibforums->lang['j_err_dl_type']);
		}

		$real_file_name = "user-".$this->users['id']."-".time().$mime_allowed[$FILE_TYPE];

		// Copy the upload to the uploads directory
		if (! @move_uploaded_file( $HTTP_POST_FILES['FILE_UPLOAD']['tmp_name'], $ibforums->vars['j_upload_dir']."/".$real_file_name) )
		{
			$this->err_journal($ibforums->lang['j_err_dl_file']);
		}
		else
		{
			@chmod( $ibforums->vars['j_upload_dir']."/".$real_file_name, 0777 );
		}
		return $real_file_name;
	}








// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// User info functions
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	function cache_friends()
	{
		global $ibforums, $DB;

		// Cache all friends
		$DB->query("SELECT f.friend_id, m.name as friend_name
					FROM ibf_jfriends f
					LEFT JOIN ibf_members m ON (m.id=f.friend_id)
					WHERE f.member_id='".$this->users['id']."' ORDER BY m.name ASC");
		while ($row = $DB->fetch_row())
		{
			$this->friends[$row['friend_id']] = $row['friend_name'];
		}

		// is a friend member
		if (in_array($ibforums->member['name'],$this->friends)) $ibforums->member['is_friend'] = 1;
	}


	// Make info about user
	function make_user_info()
	{
		global $ibforums;

		if (!$this->users['hide_email'])
		{
			$info['email'] = "<a href='".$ibforums->base_url."act=Mail&amp;CODE=00&amp;MID=".$this->users['id']."'>".$ibforums->lang['j_sending']."</a>";
		}
		else
		{
			$info['email'] = $ibforums->lang['j_private'];
		}

    	if ( $this->users['website'] and preg_match( "/^http:\/\/\S+$/", $this->users['website'] ) )
    	{
			$info['website'] = "<a href='".$this->users['website']."' target='_blank'>".$ibforums->lang['j_goto']."</a>";
		}
		else
		{
			$info['website'] = $ibforums->lang['j_no_info'];
		}

    	$info['icq']  = $this->users['icq_number'] ? $this->users['icq_number'] : $ibforums->lang['j_no_info'];
    	$info['joined'] = $this->get_date( $this->users['joined'],"d.m.Y");

		if ($this->users['j_photo'] != "")
		{
			list($p_w, $p_h) = explode( ",", $this->users['j_photo_dim'] );

 			$width  = ( $p_w ) ? "width='$p_w'"  : "";
 			$height = ( $p_h ) ? "height='$p_h'" : "";

 			if ( $this->users['j_photo_type'] == 'upload')
	 		{
 				$info['avatar'] = "<img src=\"".$ibforums->vars['j_upload_url']."/".$this->users['j_photo']."\" $width $height alt='' />";
	 		}
 			else if ( $this->users['j_photo_type'] == 'url' )
	 		{
	 			$info['avatar'] = "<img src=\"".$this->users['j_photo']."\" $width $height alt='' />";
 			}
			else
			{
				$info['avatar'] = $this->html->j_noavatar();
			}
		}
		else
		{
			$info['avatar'] = $this->html->j_noavatar();
		}

		$info['name'] = $this->users['name'];
		$info['title'] = $this->users['group_title'];
		$info['id'] = $this->users['id'];

 		list($post_page, $comment_page) = explode( "&", $this->users['j_view_prefs'] );
 		$this->users['j_post_page'] = ($post_page > 1) ? $post_page : $ibforums->vars['j_post_page'];
 		$this->users['j_comment_page'] = ($comment_page > 1) ? $comment_page : $ibforums->vars['j_comment_page'];

		// get user info block
		$this->out_data['user_info'] = $this->html->j_userinfo($info);

		// add user journal title
		if ($this->users['j_title'] and $this->users['j_title'] != "")
		{
			$this->out_data['page_title'] = $this->html->j_page_title($this->users['j_title']);
		}

		// comments block
		$this->out_data['user_info'] = str_replace("<!--IBF.BLOCK_COMMENTS-->",$this->block_comments(),$this->out_data['user_info']);

		// friends block
		if ($this->users['j_show_friends'] == 1 or $ibforums->member['id'] == $this->users['id'] or
			($this->users['j_show_friends'] == 2 and $ibforums->member['is_friend']))
		{
			$this->out_data['user_info'] = str_replace("<!--IBF.BLOCK_FRIENDS-->",$this->block_friends(),$this->out_data['user_info']);
		}

		if ($ibforums->member['id'] == $this->users['id'])
		{
			// ufriend block
			$this->out_data['user_info'] = str_replace("<!--IBF.BLOCK_UFRIEND-->",$this->block_ufriend(),$this->out_data['user_info']);
			// favorite block
			$this->out_data['user_info'] = str_replace("<!--IBF.BLOCK_FAVORITE-->",$this->block_favorite(),$this->out_data['user_info']);
			// ufavorite block
			$this->out_data['user_info'] = str_replace("<!--IBF.BLOCK_UFAVORITE-->",$this->block_ufavorite(),$this->out_data['user_info']);
			// user settings
			$this->out_data['user_info'] = str_replace("<!--IBF.SETTING_MENU-->",$this->html->j_setting_member($this->users['id']),$this->out_data['user_info']);
		}
		elseif ($ibforums->member['id'])
		{
			$this->out_data['user_info'] = str_replace("<!--IBF.SETTING_MENU-->",$this->html->j_setting_guest($ibforums->member['id'],$this->users['id']),$this->out_data['user_info']);
		}

		if ($ibforums->vars['j_enable_votes'] and $this->users['j_block_votes'])
		{
			// votes
			$total_point = 0;
			$votes = unserialize($this->users['j_votes']);
			if (is_array($votes))
			{
				foreach ($votes as $voter => $point)
				{
					$total_point += $point;
				}
				$total_point = ($total_point / count($votes));
			}
			else
			{
				$votes = array();
			}

			$td_width = round(($total_point * 20));

			$this->out_data['user_info'] = str_replace("<!--IBF.BLOCK_VOTES-->",$this->html->j_votes(count($votes),sprintf("%.1f",$total_point),$td_width),$this->out_data['user_info']);

			if ($ibforums->member['id'] and !isset($votes[$ibforums->member['id']]) and ($ibforums->member['id'] != $this->users['id']))
			{
				$this->out_data['user_info'] = str_replace("<!--IBF.VOTE_FORM-->",$this->html->j_vote_form($this->users['id'],$ibforums->member['id']),$this->out_data['user_info']);
			}
		}

		$this->out_data['user_info'] = str_replace("<!--IBF.BLOCK_CALENDAR-->",$this->block_calendar(),$this->out_data['user_info']);

		$this->out_data['user_info'] = str_replace("<!--IBF.BLOCK_STATS-->",$this->block_stats(),$this->out_data['user_info']);

		if ($ibforums->member['g_j_modview'] == 1)
		{
			$this->out_data['user_info'] = str_replace("<!--IBF.MODERATOR_MENU-->", $this->html->j_setting_moder($this->users['id'],$this->users['j_blocked'] ? $ibforums->lang['j_mod_open'] : $ibforums->lang['j_mod_close']),$this->out_data['user_info']);
		}
	}


   	// Block of last comments
	function block_comments()
	{
		global $ibforums, $DB;

		$html = $this->html->j_block_start("<a href='".$this->base_url."user=".$this->users['id']."&amp;list=comment'>".$ibforums->lang['j_last_comment']."</a>");

		if ($this->users['j_block_comments'] < 1) return $html;

		// show closed ?
		if ($ibforums->member['j_view'])
		{
			$closed = "";
		}
		else
		{
			$closed = " AND p.closed=0";
		}

		$DB->query("SELECT p.pid, p.title, p.comments, p.journal_id as id, c.post_date, c.author_name, c.author_id, c.cid
					FROM ibf_jposts p
					LEFT JOIN ibf_jcomments c ON (c.cid=p.last_cid)
					WHERE p.comments > 0 AND p.journal_id = '".$this->users['id']."'".$closed."
					ORDER BY c.post_date DESC LIMIT 0,10");

		if ($DB->get_num_rows())
		{
			while ($row = $DB->fetch_row())
			{
				$row['post_date'] = $this->get_date($row['post_date']);
				if (strlen($row['title']) > 20)
				{
					$row['title'] = substr($row['title'],0,20)."...";
					$row['title'] = preg_replace( '/&(#(\d+;?)?)?\.\.\.$/', '...', $row['title']);
				}
				if (strlen($row['title']) < 1) $row['title'] = '---';
				if (strlen($row['author_name']) > 15) $row['author_name'] = substr($row['author_name'],0,15)."...";
				if ($row['author_id'] > 0)
				{
					$row['author_name'] = "<a href='".$ibforums->base_url."showuser=".$row['author_id']."'>".$row['author_name']."</a>";
				}
				$html .= $this->html->j_block_row("[".$row['comments']."] <a href=\"".$this->base_url."user=".$row['id']."&amp;comm=".$row['pid']."&amp;view=last\">".$row['title']."</a><br />".$row['post_date']."<br />".$ibforums->lang['j_comment_added']." ".$row['author_name']);
			}
		}
		else $html .= $this->html->j_block_row($ibforums->lang['j_no_comments']);

		return $html;
	}


   	// Friends block
	function block_friends()
	{
		global $ibforums, $DB;

		if ($this->users['j_block_friends'] < 1) return "";

		$html = $this->html->j_block_start("<a href='".$this->base_url."user=".$this->users['id']."&amp;list=friends'>".$ibforums->lang['j_friend_list']."</a>");

		if ($this->users['j_block_friends'] < 2) return $html;

		if (empty($this->friends))
		{
			$html .= $this->html->j_block_row($ibforums->lang['j_no_friends']);
		}
		else
		{
			$temp = "";
			while (list($id, $name) = each($this->friends))
			{
				if (strlen($name) > 15) $name = substr($name,0,15)."...";
				$temp .= "<a href='".$ibforums->base_url."showuser=".$id."'>".$name."</a> ";
			}
			$html .= $this->html->j_block_row($temp);
		}

		return $html;
	}


   	// Ufriend block
	function block_ufriend()
	{
		global $ibforums, $DB;

		if ($this->users['j_block_ufriends'] < 1) return "";

		$html = $this->html->j_block_start("<a href='".$this->base_url."user=".$this->users['id']."&amp;list=ufriends'>".$ibforums->lang['j_ufriend_list']."</a>");

		if ($this->users['j_block_ufriends'] < 2) return $html;

		$DB->query("SELECT f.member_id, m.name
					FROM ibf_jfriends f
					LEFT JOIN ibf_members m ON (m.id = f.member_id)
					WHERE f.friend_id='".$this->users['id']."' ORDER BY m.name ASC");

		if ($DB->get_num_rows())
		{
			$temp = "";
			while ($row = $DB->fetch_row())
			{
				if (strlen($row['name']) > 15) $row['name'] = substr($row['name'],0,15)."...";
				$temp .= "<a href='".$this->base_url."user=".$row['member_id']."'>".$row['name']."</a> ";
			}
			$html .= $this->html->j_block_row($temp);
		}
		else $html .= $this->html->j_block_row($ibforums->lang['j_no_ufriend']);

		return $html;
	}


   	// Favorite block
	function block_favorite()
	{
		global $ibforums, $DB;

		if ($this->users['j_block_favorite'] < 1) return "";

		$html = $this->html->j_block_start("<a href='".$this->base_url."user=".$this->users['id']."&amp;list=favorite'>".$ibforums->lang['j_fav_list']."</a>");

		if ($this->users['j_block_favorite'] < 2) return $html;

		$DB->query("SELECT f.favorite_id, m.name
					FROM ibf_jfavorite f
					LEFT JOIN ibf_members m ON (m.id = f.favorite_id)
					WHERE f.member_id='".$this->users['id']."' ORDER BY m.name ASC");

		if ($DB->get_num_rows())
		{
			$temp = "";
			while ($row = $DB->fetch_row())
			{
				if (strlen($row['name']) > 15) $row['name'] = substr($row['name'],0,15)."...";
				$temp .= "<a href='".$this->base_url."user=".$row['favorite_id']."'>".$row['name']."</a> ";
			}
			$html .= $this->html->j_block_row($temp);
		}
		else $html .= $this->html->j_block_row($ibforums->lang['j_no_fav']);

		return $html;
	}


   	// UFavorite block
	function block_ufavorite()
	{
		global $ibforums, $DB;

		if ($this->users['j_block_ufavorite'] < 1) return "";

		$html = $this->html->j_block_start("<a href='".$this->base_url."user=".$this->users['id']."&amp;list=ufavorite'>".$ibforums->lang['j_ufav_list']."</a>");

		if ($this->users['j_block_ufavorite'] < 2) return $html;

		$DB->query("SELECT f.member_id, m.name
					FROM ibf_jfavorite f
					LEFT JOIN ibf_members m ON (m.id = f.member_id)
					WHERE f.favorite_id='".$this->users['id']."' ORDER BY m.name ASC");

		if ($DB->get_num_rows())
		{
			$temp = "";
			while ($row = $DB->fetch_row())
			{
				if (strlen($row['name']) > 15) $row['name'] = substr($row['name'],0,15)."...";
				$temp .= "<a href='".$this->base_url."user=".$row['member_id']."'>".$row['name']."</a> ";
			}
			$html .= $this->html->j_block_row($temp);
		}
		else $html .= $this->html->j_block_row($ibforums->lang['j_no_ufav']);

		return $html;
	}



	// statistics block
	function block_stats()
	{
		global $ibforums, $DB;

		if (!$ibforums->vars['j_stat_counter']) return "";
		$html = $this->html->j_block_start($ibforums->lang['j_stat_block']);
		if ($ibforums->vars['j_graph_counter'])
		{
			$html .= $this->html->j_stat_graph($this->users['id']);
		}
		else
		{
			$html .= $this->html->j_stat_text($this->users);
		}
		return $html;
	}


	function block_calendar()
	{
		global $ibforums, $DB;

		if ($this->users['j_block_calendar'] < 1) return "";

		$html = $this->html->j_block_start("<a href='".$this->base_url."user=".$this->users['id']."&amp;list=calendar'>".$ibforums->lang['j_calendar_list']."</a>");

		if ($this->users['j_block_calendar'] < 2) return $html;

		$month = array( $ibforums->lang['j_M1'], $ibforums->lang['j_M2'], $ibforums->lang['j_M3'],
						$ibforums->lang['j_M4'], $ibforums->lang['j_M5'], $ibforums->lang['j_M6'],
						$ibforums->lang['j_M7'], $ibforums->lang['j_M8'], $ibforums->lang['j_M9'],
						$ibforums->lang['j_M10'], $ibforums->lang['j_M11'], $ibforums->lang['j_M12']);

		// save offset
		$offset = $this->get_time_offset();

		// get current member mon and year
		list($cur_mon, $cur_year) = explode(",",gmdate( 'n,Y', time() + $offset));

		// difference betwen local time and user time
		$diff_date = mktime(0,0,0,1,1,1999) - (gmmktime(0,0,0,1,1,1999) - $offset);

		// make start of this month
		$db_start_date = mktime(0,0,0,$cur_mon,1,$cur_year) - $diff_date;

		// make end of this month
		$db_end_date = mktime(23,59,59,$cur_mon,31,$cur_year) - $diff_date;

		// cache database info
		$day_posts = array();
		$DB->query("SELECT post_date, pid FROM ibf_jposts
					WHERE post_date > '".$db_start_date."'
					AND post_date < '".$db_end_date."'
					AND journal_id='".$this->users['id']."'
					ORDER BY post_date ASC");
		while ($r = $DB->fetch_row())
		{
			$day_posts[gmdate('j',$r['post_date']+$offset)] = $r['pid'];
		}

		$db_start_date = $db_start_date + $diff_date;
		$time_start = getdate($db_start_date);

        // get monday first (European)
		if ($time_start['wday'] == 0) $time_start['wday'] = 6;
		else $time_start['wday'] --;

		// start calendar
		$html .= $this->html->j_cal_start($month[$cur_mon-1]." ".$cur_year);

		// draw blank row
		for ($i=0;$i<$time_start['wday'];$i++) $html .= $this->html->j_cal_blank();

		// show this month
		while ($time_start['mon'] == $cur_mon)
		{
			if ($day_posts[$time_start['mday']])
			{
				$html .= $this->html->j_cal_day("<a style='text-decoration:none' href=\"".$this->base_url."user=".$this->users['id']."&amp;list=allpost&amp;year=".$cur_year."&amp;mon=".$cur_mon."&amp;day=".$time_start['mday']."\" title='{$ibforums->lang['j_tips_allpost']}'><b>".$time_start['mday']."</b></a>");
			}
			else
			{
				$html .= $this->html->j_cal_day($time_start['mday']);
			}
			if ($time_start['wday'] == 6) $html .= $this->html->j_cal_endweek();

			// next day
			$db_start_date += 86400;
			$time_start = getdate($db_start_date);
			if ($time_start['wday'] == 0) $time_start['wday'] = 6;
			else $time_start['wday'] --;
		}

		// draw blank row if need
		if ($time_start['wday'] != 0)
		{
			for ($i=0;$i<(7-$time_start['wday']);$i++) $html .= $this->html->j_cal_blank();
		}

		// end
		$html .= $this->html->j_cal_end();
		return $html;
	}
}
?>