<?php


class journal_posts {

    var $html      = "";
	var $md5_check = "";

	function journal_posts()
	{
		global $ibforums, $journal;

		$this->md5_check = $journal->return_md5_check();

		// Loading skin
        $this->html     = $journal->load_template('skin_jposts');

		// calculate post page and view them
		if (preg_match("/^\d+$/",$ibforums->input['view'])) $this->goto_post();

		switch ($ibforums->input['aid'])
		{
			case 'new':
					$this->new_post();
					break;
			case 'edit':
					$this->edit_post();
					break;
			case 'doedit':
					$this->do_edit_post();
					break;
			case 'del':
					$this->delete_post();
					break;
			case 'close':
					$this->close_post();
					break;
			case 'open':
					$this->open_post();
					break;
			default:
					$this->show_posts();
					break;
		}
	}



// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Journal posts
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


	// Show journal posts
	function show_posts()
	{
		global $ibforums, $DB, $journal;

		// loading posting class
		require ROOT_PATH."/sources/journal/post_common.php";
		$posting = new post_common;

		// Get the first page
		$first = 0;
		if (isset($ibforums->input['st'])) $first = intval($ibforums->input['st']);
		if ($first >= $journal->users['j_posts']) $first = (floor($journal->users['j_posts'] / $journal->users['j_post_page']) * $journal->users['j_post_page']);
		if ($first < 0) $first = 0;

		// Make page jump links
		$journal->out_data['page_info'] = $this->html->j_pages($journal->build_pagelinks( array( 'TOTAL_POSS'  => $journal->users['j_posts'],
													'PER_PAGE'    => $journal->users['j_post_page'],
													'CUR_ST_VAL'  => $first,
													'L_SINGLE'    => "",
													'BASE_URL'    => $journal->base_url."user=".$journal->users['id'],
											  )));

		// Get posts
		$DB->query("SELECT * FROM ibf_jposts WHERE journal_id='".$journal->users['id']."' ORDER BY post_date DESC LIMIT ".$first.",".$journal->users['j_post_page']);

		if (!$DB->get_num_rows())
		{
			$journal->out_data['pages'] = $this->html->j_info($ibforums->lang['j_err_no_posts'])."<br />";
		}
		else
		{
			// Process posts
			$old_date = "";
			$start_post = true;
			$journal->out_data['pages'] = "";
			while ($row = $DB->fetch_row())
			{
				$row['date'] = $journal->get_date($row['post_date'],"d F Y");
				$row['time'] = $journal->get_date($row['post_date'],"H:i");

				if ($old_date != $row['date'])
				{
					if (!$start_post)
					{
						$journal->out_data['pages'] .= $this->html->j_post_bottom();
					}
					$journal->out_data['pages'] .= $this->html->j_post_top($row['date']);
				}

				// show closed ?
				if ($row['closed'] == 1 and !$ibforums->member['j_view'])
				{
					$journal->out_data['pages'] .= $this->html->j_post_closed($row);
				}
				else
				{
					// not owner post ?
					if ($journal->users['id'] != $row['author_id'])
					{
						$row['post_member'] = "{$ibforums->lang['j_comment_added']} <a style='text-decoration:none' OnMouseOver='this.style.cursor=\"hand\"' OnClick='javascript:ins(\"{$row['author_name']}\")'><b>{$row['author_name']}</b></a> -";
					}

					// user links
					if ($ibforums->member['j_edit'])
					{
						$row['links']  = $this->html->j_post_link($journal->users['id'],$row['pid'],$row['closed'] ? 'open' : 'close',$row['closed'] ? $ibforums->lang['j_open_btn'] : $ibforums->lang['j_close_btn'],$ibforums->input['st']);
					}

					// get attachments
					$row['attachment'] = $posting->get_attachment($row);

					// show image ?
					if (!$journal->users['j_show_img'])
					{
						$row['post'] = preg_replace( "#<!--emo&(.+?)-->.+?<!--endemo-->#", "\\1" , $row['post']);
						$row['post'] = preg_replace( "/<img src=[\"'](.+?)[\"'].+?".">/", "<br />".$ibforums->lang['j_image']." <a href='\\1' target='_blank'>\\1</a><br />", $row['post'] );
					}

					// word wrap
					if ($ibforums->vars['post_wordwrap'] > 0)
					{
						$row['post'] = preg_replace("#([^\s<>'\"/\.\\-\?&\n\r\%]{".$ibforums->vars['post_wordwrap']."})#i", " \\1<br />" ,$row['post']);
					}

					$row['post'] = str_replace("<br>","<br />",$row['post']);

					$journal->out_data['pages'] .= $this->html->j_post($row);
				}
				$old_date = $row['date'];
				$start_post = false;
			}
			$journal->out_data['pages'] .= $this->html->j_post_bottom();
		}

		// Add reply form if user is journal owner or user is friend and set friends access
		if (($ibforums->member['id'] == $journal->users['id']) or ($journal->users['j_friend_access'] and $ibforums->member['is_friend']))
		{
			$ibforums->input['pid'] = -1;
			$posting->reply_form(array('ADD_TITLE' => 1,
										'title' => $ibforums->lang['j_add_post'],
										'code' => 'new',
										'mode' => 'pid',
										'key' => $this->md5_check,
										'CLOSED' => 0,
										'NOCOMMENT' => 0));
		}

		$journal->title = $journal->users['name']." :: ";
		$journal->nav[] = "<a href=\"".$journal->base_url."user=".$journal->users['id']."\">".$journal->users['name']."</a>";
	}


	// Close post
	function close_post()
	{
		global $ibforums, $DB, $journal;

		// Close post only if user is journal owner or moderator or friend (if set right access)
		if (!$ibforums->member['j_edit'])
		{
			$journal->err_journal($ibforums->lang['j_err_data']);
		}

		// Check input
		if (!preg_match( "/^\d+$/", $ibforums->input['pid']))
		{
			$journal->err_journal($ibforums->lang['j_err_data']);
		}

		$DB->query("UPDATE ibf_jposts SET closed=1 WHERE pid='".$ibforums->input['pid']."' AND journal_id='".$journal->users['id']."'");

		// jump back
		if ($ibforums->input['st']) $st = "&amp;st=".$ibforums->input['st'];
		$journal->redirect_screen($ibforums->lang['j_redir_close'],$journal->base_url."user=".$journal->users['id'].$st);
	}


	// Open post
	function open_post()
	{
		global $ibforums, $DB, $journal;

		// Open post only if user is journal owner or moderator or friends (if set right access)
		if (!$ibforums->member['j_edit'])
		{
			$journal->err_journal($ibforums->lang['j_err_data']);
		}
		// Check input
		if (!preg_match( "/^\d+$/", $ibforums->input['pid']))
		{
			$journal->err_journal($ibforums->lang['j_err_data']);
		}

		$DB->query("UPDATE ibf_jposts SET closed=0 WHERE pid='".$ibforums->input['pid']."' AND journal_id='".$journal->users['id']."'");

		// jump back
		if ($ibforums->input['st']) $st = "&amp;st=".$ibforums->input['st'];
		$journal->redirect_screen($ibforums->lang['j_redir_open'],$journal->base_url."user=".$journal->users['id']."".$st);
	}


	// compile post (new post and edited)
	function compile_post()
	{
		global $ibforums, $HTTP_POST_VARS, $journal;

		// Loading parser
		require ROOT_PATH."sources/lib/post_parser.php";
		$parser = new post_parser();

		// Check post
		if (strlen(trim($HTTP_POST_VARS['Post'])) < 1)
		{
			$journal->err_journal($ibforums->lang['j_err_no_post']);
		}

		if (strlen($HTTP_POST_VARS['Post']) > ($ibforums->vars['j_max_post_length']*1024))
		{
			$journal->err_journal($ibforums->lang['j_err_too_long']);
		}

		// Check uploads
		$attach_id = $journal->process_upload();

		// make post first
		$post = $parser->convert(array( TEXT    => $ibforums->input['Post'],
										SMILIES => $ibforums->input['enableemo'] == 'yes' ? 1 : 0,
										CODE    => 1,
										HTML    => 0 ));

		// make title
		// may be title is empty after this... if only ibcode or smilie used on post
		if (strlen(trim($ibforums->input['PostTitle'])) < 1)
		{
			// ugh... Auto make title
			$ibforums->input['PostTitle'] = substr(strip_tags(str_replace("<br>"," ",$post)),0,48);
			$ex = explode(" ",$ibforums->input['PostTitle']);
			$ex = array_slice($ex,0, (count($ex) > 7) ? 7 : ((count($ex) > 1) ? count($ex)-1 : 1));
			$ibforums->input['PostTitle'] = implode(" ",$ex);
		}
		else
		{
			$ibforums->input['PostTitle'] = strip_tags(trim(str_replace( "<br>", " ", $ibforums->input['PostTitle'])));
			$ibforums->input['PostTitle'] = $parser->bad_words($ibforums->input['PostTitle']);
		}

		// remove java from post :)
		$post = preg_replace( "/alert/i"      , "&#097;lert"      , $post );
		$post = preg_replace( "/onmouseover/i", "&#111;nmouseover", $post );
		$post = preg_replace( "/onclick/i"    , "&#111;nclick"    , $post );
		$post = preg_replace( "/onload/i"     , "&#111;nload"     , $post );
		$post = preg_replace( "/onsubmit/i"   , "&#111;nsubmit"   , $post );


		// Make post array
		$rpost = array('post'			  => $post,
					   'closed'           => $ibforums->input['closed'] == 'yes' ? 1 : 0,
					   'no_comment'       => $ibforums->input['no_comment'] == 'yes' ? 1 : 0,
					   'title'            => $ibforums->input['PostTitle'],
					   'attach_id'		  => $attach_id,
					 );

		return $rpost;
	}


	// New journal post
	function new_post()
	{
		global $ibforums, $DB, $journal;

		// Add new post only if user is journal owner or friend (if enabled)
		if (!$ibforums->member['j_edit'])
		{
			$journal->err_journal($ibforums->lang['j_err_new_post']);
		}

		if ($ibforums->input['auth_key'] != $this->md5_check)
		{
			$journal->err_journal($ibforums->lang['j_err_auth']);
		}

		// make post array
		$rpost = $this->compile_post();
		$rpost['journal_id'] = $journal->users['id'];
		$rpost['author_id'] = $ibforums->member['id'];
		$rpost['author_name'] = $ibforums->member['name'];
		$rpost['post_date'] = time();
		$rpost['comments']  = 0;

		// Add post to database
		$db_string = $DB->compile_db_insert_string( $rpost );
		$DB->query("INSERT INTO ibf_jposts (" .$db_string['FIELD_NAMES']. ") VALUES (". $db_string['FIELD_VALUES'] .")");
		$rpost['pid'] = $DB->get_insert_id();

		// check tracker
		$journal->check_post_tracker($rpost['pid']);

		// Update user posts statistics
		$this->update_post_stats();

		// send to trackers
		$this->journal_tracker($rpost);

		$journal->redirect_screen($ibforums->lang['j_redir_post'],$journal->base_url."user=".$journal->users['id']);
	}



	// Edit journal post
	function edit_post()
	{
		global $ibforums, $DB, $print, $journal;

		// Edit only if member is journal owner or moderator or friends (if enabled)
		if (!$ibforums->member['j_edit'])
		{
			$journal->err_journal($ibforums->lang['j_err_edit_post']);
		}

		// Check input
		if (!preg_match( "/^\d+$/", $ibforums->input['pid']))
		{
			$journal->err_journal($ibforums->lang['j_err_edit_post']);
		}

		// Loading parser
        require ROOT_PATH."sources/lib/post_parser.php";
        $parser = new post_parser();

		require ROOT_PATH."sources/journal/post_common.php";
		$posting = new post_common;

		// Get post
		$DB->query("SELECT * FROM ibf_jposts WHERE pid='".$ibforums->input['pid']."' AND journal_id='".$journal->users['id']."' LIMIT 1");
		if (!$DB->get_num_rows())
		{
			$journal->err_journal($ibforums->lang['j_err_data']);
		}
		$row = $DB->fetch_row();

		// Get count of posts before this post
		$DB->query("SELECT COUNT(pid) as pid FROM ibf_jposts WHERE pid > '".$ibforums->input['pid']."' AND journal_id='".$journal->users['id']."'");
		$post_count = $DB->fetch_row();

		// calculate this post page in pages of posts (for return)
		$post_count = (floor($post_count['pid'] / $journal->users['j_post_page']) * $journal->users['j_post_page']);
		$post_count = ($post_count > 0) ? "&amp;st=".$post_count : "";

		// Output post and edit form
		$row['date'] = $journal->get_date($row['post_date'],"d F Y");
		$row['time'] = $journal->get_date($row['post_date'],"H:i");

		// not owner post ?
		if ($journal->users['id'] != $row['author_id'])
		{
			$row['post_member'] = "{$ibforums->lang['j_comment_added']} <a style='text-decoration:none' OnMouseOver='this.style.cursor=\"hand\"' OnClick='javascript:ins(\"{$row['author_name']}\")'><b>{$row['author_name']}</b></a> -";
		}

		// save title
		$title = $row['title'];
		$row['title'] = "<a style='text-decoration:none' href=\"".$journal->base_url."user=".$journal->users['id'].$post_count."#p".$row['pid']."\">".$row['title']."</a>";

		// back to original
		$post = $parser->unconvert($row['post'],1,0);

		// show image ?
		if (!$journal->users['j_show_img'])
		{
			$row['post'] = preg_replace( "#<!--emo&(.+?)-->.+?<!--endemo-->#", "\\1" , $row['post']);
			$row['post'] = preg_replace( "/<img src=[\"'](.+?)[\"'].+?".">/", "<br />".$ibforums->lang['j_image']." <a href='\\1' target='_blank'>\\1</a><br />", $row['post'] );
		}

		// word wrap
		if ($ibforums->vars['post_wordwrap'] > 0)
		{
			$row['post'] = preg_replace("#([^\s<>'\"/\.\\-\?&\n\r\%]{".$ibforums->vars['post_wordwrap']."})#i", " \\1<br />" ,$row['post']);
		}

		$journal->out_data['pages'] .= $this->html->j_post_top($row['date']);
		$journal->out_data['pages'] .= $this->html->j_post($row);
		$journal->out_data['pages'] .= $this->html->j_post_bottom();


		$posting->reply_form(array('ADD_TITLE' => 1,
									'title' => $ibforums->lang['j_edit_post'],
									'code' => 'doedit',
									'post_title' => $title,
									'post' => $post,
									'mode' => 'pid',
									'id' => $ibforums->input['pid'],
									'key' => $this->md5_check,
									'CLOSED' => $row['closed'],
									'NOCOMMENT' => $row['no_comment'],
									'DEL_ATTACH' => $row['attach_id'] ? 1 : 0));

		$journal->title = $ibforums->lang['j_edit_post']." :: ".$row['date']." :: ".$journal->users['name']." :: ";
		$journal->nav[] = "<a href=\"".$journal->base_url."user=".$journal->users['id']."\">".$journal->users['name']."</a>";
		$journal->nav[] = "<a href=\"".$journal->base_url."user=".$journal->users['id'].$post_count."#p".$row['pid']."\">".$row['date']."</a>";
		$journal->nav[] = $ibforums->lang['j_edit_post'];
	}



	// Update edited post
	function do_edit_post()
	{
		global $ibforums, $DB, $journal;

		// Only for journal owner or moderator or friends
		if (!$ibforums->member['j_edit'])
		{
			$journal->err_journal($ibforums->lang['j_err_edit_post']);
		}

		// Check input
		if (!preg_match( "/^\d+$/", $ibforums->input['pid']))
		{
			$journal->err_journal($ibforums->lang['j_err_edit_post']);
		}

		if ($ibforums->input['auth_key'] != $this->md5_check)
		{
			$journal->err_journal($ibforums->lang['j_err_auth']);
		}

		// make post array
		$rpost = $this->compile_post();

		// If upload presets delete old attach and add new to post array
		if ($rpost['attach_id'] != "")
		{
			$DB->query("SELECT attach_id FROM ibf_jposts WHERE pid='".$ibforums->input['pid']."'");
			$row = $DB->fetch_row();
			$journal->del_uploaded($row['attach_id']);
		}
		// If select "delete attach", delete file and clear post attach array
		elseif ($ibforums->input['DEL_ATTACH'] == "yes")
		{
			$DB->query("SELECT attach_id FROM ibf_jposts WHERE pid='".$ibforums->input['pid']."'");
			$row = $DB->fetch_row();
			$journal->del_uploaded($row['attach_id']);
			$rpost['attach_id'] = "";
		}

		// Update database
		$db_string = $DB->compile_db_update_string($rpost);
		$DB->query("UPDATE ibf_jposts SET $db_string WHERE pid='".$ibforums->input['pid']."'");

		if ($ibforums->input['st']) $st = "&amp;st=".$ibforums->input['st'];
		$journal->redirect_screen($ibforums->lang['j_redir_edit'],$journal->base_url."user=".$ibforums->input['user'].$st);
	}



	// Delete journal post
	function delete_post()
	{
		global $ibforums, $DB, $journal;

		// Delete only for journal owner or moderator or friends
		if (!$ibforums->member['j_edit'])
		{
			$journal->err_journal($ibforums->lang['j_err_edit_post']);
		}

		// Check input
		if (!preg_match( "/^\d+$/", $ibforums->input['pid']))
		{
			$journal->err_journal($ibforums->lang['j_err_edit_post']);
		}

		// Get post (last check :)
		$DB->query("SELECT * FROM ibf_jposts WHERE pid='".$ibforums->input['pid']."' AND journal_id='".$journal->users['id']."' LIMIT 1");
		if (!$DB->get_num_rows())
		{
			$journal->err_journal($ibforums->lang['j_err_data']);
		}
		$row = $DB->fetch_row();

		// Delete post and comments attachments
		if ($row['attach_id'])
		{
			$journal->del_uploaded($row['attach_id']);
		}

		$DB->query("SELECT * FROM ibf_jcomments WHERE post_id='".$ibforums->input['pid']."'");
		while ($row = $DB->fetch_row())
		{
			if ($row['attach_id'])
			{
				$journal->del_uploaded($row['attach_id']);
			}
		}

		// Delete post and comments
		$DB->query("DELETE FROM ibf_jcomments WHERE post_id='".$ibforums->input['pid']."'");
		$DB->query("DELETE FROM ibf_jposts WHERE pid='".$ibforums->input['pid']."' AND journal_id='".$journal->users['id']."'");

		// Update user statistics
		$this->update_all_stats();

		// Delete trackers
		$DB->query("DELETE FROM ibf_jtracker WHERE post_id='".$ibforums->input['pid']."'");

		$journal->redirect_screen($ibforums->lang['j_redir_del'],$journal->base_url."user=".$journal->users['id']);
	}


	// Goto post
	function goto_post()
	{
		global $ibforums, $DB, $journal, $std;

		// Check input
		if (!preg_match( "/^\d+$/", $ibforums->input['view']))
		{
			$journal->err_journal($ibforums->lang['j_err_data']);
		}

		// check if present
		$DB->query("SELECT pid FROM ibf_jposts WHERE pid = '".$ibforums->input['view']."' AND journal_id='".$journal->users['id']."'");

		$r = $DB->fetch_row();
		if (!$r['pid'])
		{
			$journal->err_journal($ibforums->lang['j_err_data']);
		}

		// Get count of posts before this post
		$DB->query("SELECT COUNT(pid) as pid FROM ibf_jposts WHERE pid > '".$r['pid']."' AND journal_id='".$journal->users['id']."'");
		$post_count = $DB->fetch_row();

		// calculate this post page in pages of posts
		$post_count = (floor($post_count['pid'] / $journal->users['j_post_page']) * $journal->users['j_post_page']);
		$post_count = ($post_count > 0) ? "&amp;st=".$post_count : "";

		// goto the post
		$std->boink_it($journal->base_url."user=".$journal->users['id'].$post_count."#p".$r['pid']);
	}


	// Update all user stats
	function update_all_stats()
	{
		global $ibforums, $DB, $journal;

		// get posts count and last post date
		$DB->query("SELECT COUNT(pid) as count, MAX(post_date) as post_date FROM ibf_jposts WHERE journal_id='".$journal->users['id']."'");
		$posts = $DB->fetch_row();

		// get comments count and last comment date
		$DB->query("SELECT COUNT(cid) as count, MAX(post_date) as post_date FROM ibf_jcomments WHERE owner_id='".$journal->users['id']."'");
		$comment = $DB->fetch_row();

		// update statistics
		$DB->query("SELECT id FROM ibf_member_extra WHERE id='".$journal->users['id']."'");
		if ($DB->get_num_rows())
		{
			$DB->query("UPDATE ibf_member_extra
						SET j_last_post='".$posts['post_date']."',
							j_last_comment='".$comment['post_date']."',
							j_posts='".$posts['count']."',
							j_comments='".$comment['count']."'
						WHERE id='".$journal->users['id']."'");
		}
		else
		{
			$DB->query("INSERT INTO ibf_member_extra
						SET j_last_post='".$posts['post_date']."',
							j_last_comment='".$comment['post_date']."',
							j_posts='".$posts['count']."',
							j_comments='".$comment['count']."',
							id='".$journal->users['id']."'");
		}
	}

	function update_post_stats()
	{
		global $ibforums, $DB, $journal;

		// get posts count and last post date
		$DB->query("SELECT COUNT(pid) as count, MAX(post_date) as post_date FROM ibf_jposts WHERE journal_id='".$journal->users['id']."'");
		$posts = $DB->fetch_row();

		// update statistics
		$DB->query("SELECT id FROM ibf_member_extra WHERE id='".$journal->users['id']."'");
		if ($DB->get_num_rows())
		{
			$DB->query("UPDATE ibf_member_extra
						SET j_last_post='".$posts['post_date']."',
							j_posts='".$posts['count']."'
						WHERE id='".$journal->users['id']."'");
		}
		else
		{
			$DB->query("INSERT INTO ibf_member_extra
						SET j_last_post='".$posts['post_date']."',
							j_posts='".$posts['count']."',
							id='".$journal->users['id']."'");
		}
	}


	// journal tracker
	function journal_tracker($post_row=array())
	{
		global $ibforums, $DB, $journal;

		require "./sources/lib/emailer.php";
		$this->email = new emailer();

		// don't process closed journal
		if ($journal->users['j_public'] == 0) return;

		$links = $journal->base_url."user=".$journal->users['id'];

		$DB->query("SELECT tr.journal_id, m.name, m.email, m.id, m.language
				    FROM ibf_jtracker tr
					LEFT JOIN ibf_members m ON (m.id=tr.member_id)
				    WHERE tr.journal_id='".$journal->users['id']."' AND tr.member_id<>'".$ibforums->member['id']."'");

		if ($DB->get_num_rows())
		{
			while ( $r = $DB->fetch_row() )
			{
				$r['is_friend'] = (in_array($r['name'],$journal->friends)) ? 1 : ($r['id'] == $journal->users['id'] ? 1 : 0);

				// if journal 'only to friends' send posts only to friends
				if (($journal->users['j_public'] == 1) or ($journal->users['j_public'] == 2 and $r['is_friend']))
				{
					// send closed post only to friends
					if ($post_row['closed'] == 0 or ($post_row['closed'] == 1 and $r['is_friend']))
					{
						$r['language'] = $r['language'] ? $r['language'] : 'en';

						$this->email->get_template("journal_post", $r['language']);
						$this->email->build_message(array(
														'LINKS'           => $links,
														'JOURNAL'         => $journal->users['name'],
														'TITLE'           => $post_row['title'],
														'POST'            => $post_row['post'],
														'NAME'            => $r['name'],
													  ) );
						$this->email->to      = $r['email'];
						$this->email->send_mail();
					}
				}
			}
		}
	}

}
?>