<?php


class journal_setup {

    var $html      = "";
	var $md5_check = "";

	function journal_setup()
	{
		global $ibforums, $journal, $std;

		$this->md5_check = $journal->return_md5_check();

		// loading lang
		$ibforums->lang = $std->load_words($ibforums->lang, 'lang_jsetup', $ibforums->lang_id);

		// Loading skin
		$this->html     = $journal->load_template('skin_jsetup');

		switch ($ibforums->input['set'])
		{
			case '01':
					$this->page_settings();
					break;
			case '02':
					$this->page_access();
					break;
			case '03':
					$this->page_photo();
					break;
			case '04':
					$this->page_friends();
					break;
			case '05':
					$this->page_favorite();
					break;
			case '06':
					$this->page_tracker();
					break;
			case '07':
					$this->page_jtracker();
					break;
			case '08':
					$this->page_design();
					break;


			case '09':
					$this->edit_friends();
					break;
			default:
					$this->page_settings();
					break;
		}
	}


// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Journal settings
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	// Setting navigation
	function nav_settings($page=0)
	{
		global $ibforums, $journal;

		$sel = array( array('01', $ibforums->lang['j_p_setting']),
					  array('02', $ibforums->lang['j_p_access']),
					  array('03', $ibforums->lang['j_p_photo']),
					  array('04', $ibforums->lang['j_p_friend']),
					  array('05', $ibforums->lang['j_p_favorite']),
					  array('06', $ibforums->lang['j_p_track']),
					  array('07', $ibforums->lang['j_p_jtrack']),
					  array('08', $ibforums->lang['j_p_design']));

		$opt = "<select name='set' class='inftexinput'>";
		foreach ($sel as $id => $data)
		{
			$opt .= ($id == $page) ? "<option value='".$data[0]."' selected='selected'>".$data[1]."\n" : "<option value='".$data[0]."'>".$data[1]."\n";
		}
		$opt .= "</select>";

		$journal->out_data['pages'] = $this->html->j_nav_settings($journal->users['id'],$opt);
	}


	// Main settings
	function page_settings()
	{
		global $ibforums, $journal;

		// Only for owner
		if ($journal->users['id'] != $ibforums->member['id'])
		{
			$journal->err_journal($ibforums->lang['j_err_hack']);
		}

		// Make parameters
 		if ($ibforums->vars['j_ppage_contents'] == "")
		{
			$ibforums->vars['j_ppage_contents'] = '5,10,15,20,25,30,35,40';
		}

 		list($post_page, $comment_page) = explode( "&", $journal->users['j_view_prefs'] );

 		if ($post_page == "") $post_page = -1;
 		if ($comment_page == "") $comment_page = -1;

 		$pp_a = array();
 		$pp_a[] = array( '-1', $ibforums->lang['j_use_default'] );

 		foreach( explode( ',', $ibforums->vars['j_ppage_contents'] ) as $n )
 		{
 			$n      = intval(trim($n));
 			$pp_a[] = array( $n, $n );
 		}

		$data['j_post_page'] = "<select name='j_post_page' class='inftexinput'>";
		$data['j_comment_page'] = "<select name='j_comment_page' class='inftexinput'>";
 		foreach( $pp_a as $id => $dat )
 		{
 			$data['j_post_page'] .= ($dat[0] == $post_page) ? "<option value='".$dat[0]."' selected='selected'>".$dat[1]."\n" : "<option value='".$dat[0]."'>".$dat[1]."\n";
 			$data['j_comment_page'] .= ($dat[0] == $comment_page) ? "<option value='".$dat[0]."' selected='selected'>".$dat[1]."\n" : "<option value='".$dat[0]."'>".$dat[1]."\n";
 		}
		$data['j_post_page'] .= "</select>";
		$data['j_comment_page'] .= "</select>";


		$data['j_block_friends'] = "<select name='j_block_friends' class='inftexinput'>";
		$data['j_block_ufriends'] = "<select name='j_block_ufriends' class='inftexinput'>";
		$data['j_block_favorite'] = "<select name='j_block_favorite' class='inftexinput'>";
		$data['j_block_ufavorite'] = "<select name='j_block_ufavorite' class='inftexinput'>";
		$data['j_block_calendar'] = "<select name='j_block_calendar' class='inftexinput'>";

		$opt_d = array ('0' => $ibforums->lang['no'], '1' => $ibforums->lang['as_link'], '2' => $ibforums->lang['as_list']);

 		foreach ($opt_d as $id => $dat)
 		{
 			$data['j_block_friends'] .= ($id == $journal->users['j_block_friends']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
 			$data['j_block_ufriends'] .= ($id == $journal->users['j_block_ufriends']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
 			$data['j_block_favorite'] .= ($id == $journal->users['j_block_favorite']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
 			$data['j_block_ufavorite'] .= ($id == $journal->users['j_block_ufavorite']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
 			$data['j_block_calendar'] .= ($id == $journal->users['j_block_calendar']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
 		}
		$data['j_block_friends'] .= "</select>";
		$data['j_block_ufriends'] .= "</select>";
		$data['j_block_favorite'] .= "</select>";
		$data['j_block_ufavorite'] .= "</select>";
		$data['j_block_calendar'] .= "</select>";

		$data['j_block_comments'] = "<select name='j_block_comments' class='inftexinput'>";
 		$data['j_block_comments'] .= $journal->users['j_block_comments'] ? "<option value='1' selected='selected'>".$ibforums->lang['as_list']."</option>\n<option value='0'>".$ibforums->lang['as_link']."</option>"
 											   : "<option value='1'>".$ibforums->lang['as_list']."</option>\n<option value='0' selected='selected'>".$ibforums->lang['as_link']."</option>";
		$data['j_block_comments'] .= "</select>";

		$data['j_block_vote'] = "<select name='j_block_votes' class='inftexinput'>";
 		$data['j_block_vote'] .= $journal->users['j_block_votes'] ? "<option value='1' selected='selected'>".$ibforums->lang['yes']."</option>\n<option value='0'>".$ibforums->lang['no']."</option>"
 											   : "<option value='1'>".$ibforums->lang['yes']."</option>\n<option value='0' selected='selected'>".$ibforums->lang['no']."</option>";
		$data['j_block_vote'] .= "</select>";

		if ($ibforums->vars['j_enable_votes'])
		{
			$data['j_block_votes'] = $this->html->j_block_votes($data);
		}


		$data['j_show_img'] = "<select name='j_show_img' class='inftexinput'>";
 		$data['j_show_img'] .= $journal->users['j_show_img'] ? "<option value='1' selected='selected'>".$ibforums->lang['yes']."</option>\n<option value='0'>".$ibforums->lang['no']."</option>"
 											   : "<option value='1'>".$ibforums->lang['yes']."</option>\n<option value='0' selected='selected'>".$ibforums->lang['no']."</option>";
		$data['j_show_img'] .= "</select>";


		$data['j_info_pos'] = "<select name='j_info_pos' class='inftexinput'>";
 		$data['j_info_pos'] .= $journal->users['j_info_pos'] ? "<option value='1' selected='selected'>".$ibforums->lang['left']."</option>\n<option value='0'>".$ibforums->lang['right']."</option>"
 											   : "<option value='1'>".$ibforums->lang['left']."</option>\n<option value='0' selected='selected'>".$ibforums->lang['right']."</option>";
		$data['j_info_pos'] .= "</select>";

		$data['j_auto_mail'] = "<select name='j_auto_mail' class='inftexinput'>";
 		$data['j_auto_mail'] .= $journal->users['j_auto_mail'] ? "<option value='1' selected='selected'>".$ibforums->lang['yes']."</option>\n<option value='0'>".$ibforums->lang['no']."</option>"
 											   : "<option value='1'>".$ibforums->lang['yes']."</option>\n<option value='0' selected='selected'>".$ibforums->lang['no']."</option>";
		$data['j_auto_mail'] .= "</select>";

		// Image thumb setting
		$data['j_show_thumb'] = "<select name='j_show_thumb' class='inftexinput'>";
 		$data['j_show_thumb'] .= $journal->users['j_show_thumb'] ? "<option value='1' selected='selected'>".$ibforums->lang['yes']."</option>\n<option value='0'>".$ibforums->lang['no']."</option>"
 											   : "<option value='1'>".$ibforums->lang['yes']."</option>\n<option value='0' selected='selected'>".$ibforums->lang['no']."</option>";
		$data['j_show_thumb'] .= "</select>";

		$data['j_th_width'] = $journal->users['j_th_width'];
		$data['j_th_height'] = $journal->users['j_th_height'];


		$data['j_title'] = $journal->users['j_title'];

		$data['key'] = $this->md5_check;
		$data['id'] = $journal->users['id'];

		$this->nav_settings(0);
 		$journal->out_data['pages'] .= $this->html->j_page_settings($data);

		$journal->title = $ibforums->lang['j_page_setting']." :: ".$journal->users['name']." :: ";
 		$journal->nav[] = "<a href='".$journal->base_url."user=".$journal->users['id']."'>".$journal->users['name']."</a>";
		$journal->nav[] = $ibforums->lang['j_page_setting'];
	}


	// Access settings
	function page_access()
	{
		global $ibforums, $journal;

		// Only for owner
		if ($journal->users['id'] != $ibforums->member['id'])
		{
			$journal->err_journal($ibforums->lang['j_err_hack']);
		}

		$opt_d = array ( '1' => $ibforums->lang['yes_all'], '3' => $ibforums->lang['yes_reg'], '2' => $ibforums->lang['friend_only'], '0' => $ibforums->lang['no']);
		$data['j_public'] = "<select name='j_public' class='inftexinput'>";
		foreach ($opt_d as $id => $dat)
 		{
 			$data['j_public'] .= ($id == $journal->users['j_public']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
		}
		$data['j_public'] .= "</select>";

		$opt_d = array ( '1' => $ibforums->lang['yes'], '0' => $ibforums->lang['no'], '2' => $ibforums->lang['friend_only']);
		$data['j_must_edit'] = "<select name='j_must_edit' class='inftexinput'>";
		$data['j_must_del'] = "<select name='j_must_del' class='inftexinput'>";
		$data['j_show_friends'] = "<select name='j_show_friends' class='inftexinput'>";
		foreach ($opt_d as $id => $dat)
 		{
 			$data['j_must_edit'] .= ($id == $journal->users['j_edit_comment']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
 			$data['j_must_del'] .= ($id == $journal->users['j_del_comment']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
 			$data['j_show_friends'] .= ($id == $journal->users['j_show_friends']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
 		}
		$data['j_must_edit'] .= "</select>";
		$data['j_must_del'] .= "</select>";
		$data['j_show_friends'] .= "</select>";

		$opt_d = array ( '3' => $ibforums->lang['yes_all'], '1' => $ibforums->lang['yes_reg'], '2' => $ibforums->lang['friend_only'], '0' => $ibforums->lang['no']);
		$data['j_allow_upload'] = "<select name='j_allow_upload' class='inftexinput'>";
		$data['j_allow_codes'] = "<select name='j_allow_codes' class='inftexinput'>";
		$data['j_must_add'] = "<select name='j_must_add' class='inftexinput'>";
 		foreach ($opt_d as $id => $dat)
 		{
			$data['j_must_add'] .= ($id == $journal->users['j_add_comment']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
 			$data['j_allow_upload'] .= ($id == $journal->users['j_show_friends']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
 			$data['j_allow_codes'] .= ($id == $journal->users['j_allow_codes']) ? "<option value='".$id."' selected='selected'>".$dat."\n" : "<option value='".$id."'>".$dat."\n";
		}
		$data['j_must_add'] .= "</select>";
		$data['j_allow_upload'] .= "</select>";
		$data['j_allow_codes'] .= "</select>";

		$data['j_friend_access'] = "<select name='j_friend_access' class='inftexinput'>";
 		$data['j_friend_access'] .= $journal->users['j_friend_access'] ? "<option value='1' selected='selected'>".$ibforums->lang['yes']."</option>\n<option value='0'>".$ibforums->lang['no']."</option>"
 											   : "<option value='1'>".$ibforums->lang['yes']."</option>\n<option value='0' selected='selected'>".$ibforums->lang['no']."</option>";
		$data['j_friend_access'] .= "</select>";

		$data['key'] = $this->md5_check;
		$data['id'] = $journal->users['id'];

		$this->nav_settings(1);
 		$journal->out_data['pages'] .= $this->html->j_page_access($data);

		$journal->title = $ibforums->lang['j_page_access']." :: ".$journal->users['name']." :: ";
 		$journal->nav[] = "<a href='".$journal->base_url."user=".$journal->users['id']."'>".$journal->users['name']."</a>";
		$journal->nav[] = $ibforums->lang['j_page_access'];
	}



	// Photo setting
	function page_photo()
	{
 		global $ibforums, $journal;

		// Only for owner
		if ($journal->users['id'] != $ibforums->member['id'])
		{
			$journal->err_journal($ibforums->lang['j_err_hack']);
		}

 		$p_max = $ibforums->vars['j_photo_max'];

 		$ibforums->lang['j_photo_desc'] = sprintf( $ibforums->lang['j_photo_desc'], $p_max);

 		list($p_w, $p_h) = explode( ",", $journal->users['j_photo_dim'] );

 		$data['cur_photo'] = $ibforums->lang['j_pph_none'];
 		$data['cur_type']  = "";
 		$data['url_photo'] = "";

 		$width  = ( $p_w ) ? "width='$p_w'"  : "";
 		$height = ( $p_h ) ? "height='$p_h'" : "";

 		$data['show_size'] = str_replace( ",", " X ", $journal->users['j_photo_dim'] );

 		if ( $journal->users['j_photo_type'] == 'upload' )
 		{
 			$data['cur_type']  = $ibforums->lang['j_pph_t_upload'];
 			$data['cur_photo'] = "<img src=\"".$ibforums->vars['j_upload_url']."/".$journal->users['j_photo']."\" $width $height alt='' />";
 		}
 		else if ( $journal->users['j_photo_type'] == 'url' )
 		{
 			$data['cur_type']  = $ibforums->lang['j_pph_t_url'];
 			$data['cur_photo'] = "<img src=\"".$journal->users['j_photo']."\" $width $height alt='' />";
 			$data['url_photo'] = $journal->users['j_photo'];
 		}

		$data['key'] = $this->md5_check;
		$data['id'] = $journal->users['id'];

		$this->nav_settings(2);
 		$journal->out_data['pages'] .= $this->html->j_page_photo($data);

 		if ($p_max)
 		{
 			$journal->out_data['pages'] = str_replace( "<!--IPB.UPLOAD-->", $this->html->j_photo_upload($p_max * 1024), $journal->out_data['pages'] );
 		}

		$journal->title = $ibforums->lang['j_page_photo']." :: ".$journal->users['name']." :: ";
 		$journal->nav[] = "<a href='".$journal->base_url."&amp;user=".$journal->users['id']."'>".$journal->users['name']."</a>";
		$journal->nav[] = $ibforums->lang['j_page_photo'];
	}



	// Friends setting
	function page_friends()
	{
		global $ibforums, $DB, $journal;

		if ($journal->users['id'] != $ibforums->member['id'])
		{
			$journal->err_journal($ibforums->lang['j_err_hack']);
		}

		$this->nav_settings(3);
 		$journal->out_data['pages'] .= $this->html->j_friend_header();

 		$DB->query("SELECT j.friend_id, j.member_id, j.friend_desc, m.name as friend_name
					FROM ibf_jfriends j
					LEFT JOIN ibf_members m ON (m.id=j.friend_id)
					WHERE j.member_id='".$journal->users['id']."' ORDER BY m.name ASC");

 		if ( $DB->get_num_rows() )
 		{

 			$journal->out_data['pages'] .= $this->html->j_friend_table_header();
 			while ( $row = $DB->fetch_row() )
 			{
 				$journal->out_data['pages'] .= $this->html->j_render_friend_row($row);
 			}
 			$journal->out_data['pages'] .= $this->html->j_end_friend_table();
 		}
 		else
 		{
 			$journal->out_data['pages'] .= $this->html->j_friend_none();
 		}

 		$name_to_enter = "";

 		if ($ibforums->input['MID'])
 		{
 			if ( preg_match( "/^(\d+)$/", $ibforums->input['MID'] ) )
 			{
 				$DB->query("SELECT name, id FROM ibf_members WHERE id='".$ibforums->input['MID']."'");
 				$memb = $DB->fetch_row();

 				if ($memb['id'])
 				{
 					$name_to_enter = $memb['name'];
 				}
 			}
 		}

 		$journal->out_data['pages'] .= $this->html->j_friend_add($journal->users['id'],$name_to_enter);
 		$journal->out_data['pages'] .= $this->html->j_friend_end();

		$journal->title = $ibforums->lang['j_page_friend']." :: ".$journal->users['name']." :: ";
 		$journal->nav[] = "<a href='".$journal->base_url."user=".$journal->users['id']."'>".$journal->users['name']."</a>";
		$journal->nav[] = $ibforums->lang['j_page_friend'];
	}



	// Edit friend
 	function edit_friends()
	{
 		global $ibforums, $DB, $journal;

		if ($journal->users['id'] != $ibforums->member['id'])
		{
			$journal->err_journal($ibforums->lang['j_err_hack']);
		}

 		if (!$ibforums->input['MID'])
 		{
			$journal->err_journal($ibforums->lang['j_err_no_user']);
 		}

 		if (! preg_match( "/^(\d+)$/", $ibforums->input['MID'] ) )
 		{
			$journal->err_journal($ibforums->lang['j_err_no_user']);
 		}

 		$DB->query("SELECT j.friend_id, j.member_id, j.friend_desc, m.name as friend_name
					FROM ibf_jfriends j
					LEFT JOIN ibf_members m ON (m.id=j.friend_id)
					WHERE j.member_id='".$journal->users['id']."' AND j.friend_id='".$ibforums->input['MID']."'");
 		$memb = $DB->fetch_row();

 		if (!$memb['friend_id'])
 		{
			$journal->err_journal($ibforums->lang['j_err_no_user']);
 		}

		$this->nav_settings(3);
 		$journal->out_data['pages'] .= $this->html->j_friend_header();
 		$journal->out_data['pages'] .= $this->html->j_friend_edit($memb);
 		$journal->out_data['pages'] .= $this->html->j_friend_end();

		$journal->title = $ibforums->lang['j_page_friend']." :: ".$journal->users['name']." :: ";
 		$journal->nav[] = "<a href='".$journal->base_url."user=".$journal->users['id']."'>".$journal->users['name']."</a>";
		$journal->nav[] = $ibforums->lang['j_page_friend'];
 	}


	// Favorite setting
	function page_favorite()
	{
		global $ibforums, $DB, $journal;

		if ($journal->users['id'] != $ibforums->member['id'])
		{
			$journal->err_journal($ibforums->lang['j_err_hack']);
		}

		$this->nav_settings(4);
 		$journal->out_data['pages'] .= $this->html->j_fav_header();


    	// Cache ufriend
		$ufriends = array();
		$ufriends[] = $ibforums->member['id'];
		$DB->query("SELECT member_id FROM ibf_jfriends WHERE friend_id='".$ibforums->member['id']."'");
		while ($row = $DB->fetch_row())
		{
			$ufriends[] = $row['member_id'];
		}


 		$DB->query("SELECT f.favorite_id, f.member_id, m.name as favorite_name, me.j_public, me.j_blocked
					FROM ibf_jfavorite f
					LEFT JOIN ibf_members m ON (m.id=f.favorite_id)
					LEFT JOIN ibf_member_extra me ON (me.id=f.favorite_id)
					WHERE f.member_id='".$journal->users['id']."' ORDER BY m.name ASC");

 		if ( $DB->get_num_rows() )
 		{

 			$journal->out_data['pages'] .= $this->html->j_fav_theader();
 			while ( $row = $DB->fetch_row() )
 			{
				if ($row['j_blocked'])
				{
					$row['j_access_img'] = "<img src='".$ibforums->vars['html_url']."/sys-img/j_blocked.gif' border='0'  alt='".$ibforums->lang['j_tips_blocked']."' />";
					$row['favorite_name'] = "<strong>".$row['favorite_name']."</strong>";
				}
				elseif ($row['j_public'] == 0)
				{
					$row['j_access_img'] = "<img src='".$ibforums->vars['html_url']."/sys-img/j_closeall.gif' border='0'  alt='".$ibforums->lang['j_tips_closed']."' />";
					$row['favorite_name'] = "<strong>".$row['favorite_name']."</strong>";
				}
				elseif ($row['j_public'] == 2 and !in_array($row['id'],$ufriends))
				{
					$row['j_access_img'] = "<img src='".$ibforums->vars['html_url']."/sys-img/j_close.gif' border='0'  alt='".$ibforums->lang['j_tips_onlyfriend']."' />";
					$row['favorite_name'] = "<strong><a href='".$journal->base_url."user=".$row['favorite_id']."' title='".$ibforums->lang['j_tips_journal']."'>".$row['favorite_name']."</a></strong>";
				}
				else
				{
					$row['favorite_name'] = "<strong><a href='".$journal->base_url."user=".$row['favorite_id']."' title='".$ibforums->lang['j_tips_journal']."'>".$row['favorite_name']."</a></strong>";
					$row['j_access_img'] = "&nbsp;";
				}

 				$journal->out_data['pages'] .= $this->html->j_fav_row($row);
 			}
 			$journal->out_data['pages'] .= $this->html->j_fav_tend();
 		}
 		else
 		{
 			$journal->out_data['pages'] .= $this->html->j_fav_none();
 		}

 		$name_to_enter = "";

 		if ($ibforums->input['MID'])
 		{
 			if ( preg_match( "/^(\d+)$/", $ibforums->input['MID'] ) )
 			{
 				$DB->query("SELECT name, id FROM ibf_members WHERE id='".$ibforums->input['MID']."'");
 				$memb = $DB->fetch_row();

 				if ($memb['id'])
 				{
 					$name_to_enter = $memb['name'];
 				}
 			}
 		}
 		$journal->out_data['pages'] .= $this->html->j_fav_end($journal->users['id'],$name_to_enter);

		$journal->title = $ibforums->lang['j_page_fav']." :: ".$journal->users['name']." :: ";
 		$journal->nav[] = "<a href='".$journal->base_url."&amp;user=".$journal->users['id']."'>".$journal->users['name']."</a>";
		$journal->nav[] = $ibforums->lang['j_page_fav'];
	}



	// tracker
 	function page_tracker()
	{
 		global $ibforums, $DB, $journal;

		if ($ibforums->member['id'] != $journal->users['id'])
		{
			$journal->err_journal($ibforums->lang['j_err_hack']);
		}

		$this->nav_settings(5);
 		$journal->out_data['pages'] .= $this->html->j_tr_header($journal->users['id']);


    	// Cache ufriend
		$ufriends = array();
		$ufriends[] = $ibforums->member['id'];
		$DB->query("SELECT member_id FROM ibf_jfriends WHERE friend_id='".$ibforums->member['id']."'");
		while ($row = $DB->fetch_row())
		{
			$ufriends[] = $row['member_id'];
		}


		// support auto delete subscription
 		$auto_explain = $ibforums->lang['no_auto_prune'];
 		if ($ibforums->vars['subs_autoprune'] > 0)
 		{
			if ( time() % 2 )
			{
				$time_limit = time() - ($ibforums->vars['subs_autoprune'] * 86400);
				$DB->query("SELECT tr.trid
							FROM ibf_jtracker tr, ibf_jposts p, ibf_jcomments c
							WHERE p.pid=tr.post_id AND p.last_cid=c.cid AND c.post_date < '".$time_limit."'");

				$trids = array();
				while ($r = $DB->fetch_row())
				{
					$trids[] = $r['trid'];
				}
				if (count($trids) > 0)
				{
					$DB->query("DELETE FROM ibf_jtracker WHERE trid IN (".implode(",",$trids).")");
				}
			}
			$auto_explain = sprintf( $ibforums->lang['auto_prune'], $ibforums->vars['subs_autoprune'] );
 		}

 		// Do we have an incoming date cut?
 		$date_cut   = intval($ibforums->input['datecut']) != "" ? intval($ibforums->input['datecut']) : 30;
 		$date_query = $date_cut != 1000 ? " AND c.post_date > '".(time() - ($date_cut*86400))."' " : "";

		// big query ...
 		$DB->query("SELECT tr.trid, tr.post_id, tr.start_date,
					p.pid, p.title, p.comments, p.closed, p.post_date,
					c.post_date as last_post, c.author_name, c.author_id,
					me.j_public, me.j_title, me.j_blocked, m.name, m.id
					FROM ibf_jtracker tr
					LEFT JOIN ibf_jposts p ON (p.pid=tr.post_id)
					LEFT JOIN ibf_jcomments c ON (c.cid=p.last_cid)
					LEFT JOIN ibf_member_extra me ON (me.id=p.journal_id)
					LEFT JOIN ibf_members m ON (m.id=p.journal_id)
					WHERE tr.member_id='".$journal->users['id']."' AND tr.journal_id=0 $date_query
					ORDER BY p.journal_id, c.post_date DESC");

 		if ( $DB->get_num_rows() )
 		{
 			$last_journal_id = -1;

 			while($row = $DB->fetch_row())
 			{
 				if ($last_journal_id != $row['id'])
 				{
 					$last_journal_id = $row['id'];

 					$journal->out_data['pages'] .= $this->html->j_tr_subrow($row['id'], $row['name'], $row['j_title']);
 				}

				$row['last_poster'] = ($row['author_id'] != 0)
										? "<b><a href='".$ibforums->base_url."showuser=".$row['author_id']."'>".$row['author_name']."</a></b>"
										: "-".$row['author_name']."-";

				$row['last_post_date'] = $journal->get_date($row['last_post']);

				$row['start_date'] = $journal->get_date($row['start_date']);

				$pages = 1;

				if ($row['comments'])
				{
					if ((($row['comments'] + 1) % $ibforums->vars['j_comment_page']) == 0)
					{
						$pages = ($row['comments'] + 1) / $ibforums->vars['j_comment_page'];
					}
					else
					{
						$number = (($row['comments'] + 1) / $ibforums->vars['j_comment_page']);
						$pages = ceil($number);
					}
				}

				if ($pages > 1)
				{
					$row['PAGES'] = "( ";
					for ($i = 0 ; $i < $pages ; ++$i )
					{
						$real_no = $i * $ibforums->vars['j_comment_page'];
						$page_no = $i + 1;
						if ($page_no == 4)
						{
							$row['PAGES'] .= "<a href='".$journal->base_url."user=".$row['id']."&amp;comm=".$row['pid']."&amp;st=".($pages - 1) * $ibforums->vars['j_comment_page']."'>...".$pages." </a>";
							break;
						}
						else
						{
							$row['PAGES'] .= "<a href='".$journal->base_url."user=".$row['id']."&amp;comm=".$row['pid']."&amp;st=".$real_no."'>".$page_no." </a>";
						}
					}
					$row['PAGES'] .= ")";
				}

				if ($row['comments'] < 0) $row['comments'] = 0;


				if ($row['j_blocked'])
				{
					$row['j_access_img'] = "<img src='".$ibforums->vars['html_url']."/sys-img/j_blocked.gif' border='0'  alt='".$ibforums->lang['j_tips_blocked']."' />";
				}
				elseif ($row['j_public'] == 0)
				{
					$row['j_access_img'] = "<img src='".$ibforums->vars['html_url']."/sys-img/j_closeall.gif' border='0'  alt='".$ibforums->lang['j_tips_closed']."' />";
				}
				elseif ($row['j_public'] == 2 and !in_array($row['id'],$ufriends))
				{
					$row['j_access_img'] = "<img src='".$ibforums->vars['html_url']."/sys-img/j_close.gif' border='0'  alt='".$ibforums->lang['j_tips_onlyfriend']."' />";
				}
				else
				{
					$row['j_access_img'] = "&nbsp;";
				}

				if ($row['j_public'] == 0 or $row['j_blocked'])
				{
					$row['last_post_date'] = '--';
					$row['last_poster'] = '--';
					$row['comments'] = '--';
				}

				$journal->out_data['pages'] .= $this->html->j_tr_row($row);
			}
		}
		else
		{
			$journal->out_data['pages'] .= $this->html->j_tr_none();
		}

		// Build date box
		$date_box = "<option value='1'>".$ibforums->lang['j_tr_today']."</option>\n";

		foreach( array( 1,7,14,21,30,60,90,365 ) as $day )
		{
			$selected = $day == $date_cut ? ' selected="selected"' : '';
			$date_box .= "<option value='{$day}'{$selected}>".sprintf( $ibforums->lang['j_tr_day'], $day )."</option>\n";
		}

		$date_box .= "<option value='1000'>".$ibforums->lang['j_tr_all']."</option>\n";

		$journal->out_data['pages'] .= $this->html->j_tr_end($journal->users['id'],$auto_explain, $date_box);


		$journal->title = $ibforums->lang['j_page_track']." :: ".$journal->users['name']." :: ";
 		$journal->nav[] = "<a href='".$journal->base_url."user=".$journal->users['id']."'>".$journal->users['name']."</a>";
		$journal->nav[] = $ibforums->lang['j_page_track'];
 	}



	// journal tracker
 	function page_jtracker()
 	{
 		global $ibforums, $DB, $journal;

		if ($ibforums->member['id'] != $journal->users['id'])
		{
			$journal->err_journal($ibforums->lang['j_err_hack']);
		}

    	// Cache ufriend
		$ufriends = array();
		$ufriends[] = $ibforums->member['id'];
		$DB->query("SELECT member_id FROM ibf_jfriends WHERE friend_id='".$ibforums->member['id']."'");
		while ($row = $DB->fetch_row())
		{
			$ufriends[] = $row['member_id'];
		}

		$this->nav_settings(6);
 		$journal->out_data['pages'] .= $this->html->j_jtr_header();

 		$DB->query("SELECT tr.trid, tr.journal_id, tr.start_date, tr.member_id,
					me.j_public, me.j_title, me.j_comments, me.j_posts, me.j_last_post, me.j_last_comment, m.name, m.id, me.j_blocked
					FROM ibf_jtracker tr
					LEFT JOIN ibf_member_extra me ON (me.id=tr.journal_id)
					LEFT JOIN ibf_members m ON (m.id=tr.journal_id)
					WHERE tr.member_id='".$journal->users['id']."' AND tr.journal_id > '0'
					ORDER BY tr.journal_id DESC");

 		if ($DB->get_num_rows())
 		{
 			while($row = $DB->fetch_row())
 			{
				if ($row['j_blocked'])
				{
					$row['j_access_img'] = "<img src='".$ibforums->vars['html_url']."/sys-img/j_blocked.gif' border='0'  alt='".$ibforums->lang['j_tips_blocked']."' />";
					$row['name'] = "<strong>".$row['name']."</strong>";
				}
				elseif ($row['j_public'] == 0)
				{
					$row['j_access_img'] = "<img src='".$ibforums->vars['html_url']."/sys-img/j_closeall.gif' border='0'  alt='".$ibforums->lang['j_tips_closed']."' />";
					$row['name'] = "<strong>".$row['name']."</strong>";
				}
				elseif ($row['j_public'] == 2 and !in_array($row['id'],$ufriends))
				{
					$row['j_access_img'] = "<img src='".$ibforums->vars['html_url']."/sys-img/j_close.gif' border='0'  alt='".$ibforums->lang['j_tips_onlyfriend']."' />";
					$row['name'] = "<strong><a href='".$journal->base_url."user=".$row['journal_id']."' title='".$ibforums->lang['j_tips_journal']."'>".$row['name']."</a></strong>";
				}
				else
				{
					$row['name'] = "<strong><a href='".$journal->base_url."user=".$row['journal_id']."' title='".$ibforums->lang['j_tips_journal']."'>".$row['name']."</a></strong>";
					$row['j_access_img'] = "&nbsp;";
				}

				if ($row['j_public'] == 0 or $row['j_blocked'])
				{
					$row['j_comments'] = "--";
					$row['j_posts'] = "--";
					$row['j_last_post'] = "--";
					$row['j_last_comment'] = "--";
				}
				else
				{
					$row['j_last_post'] = $row['j_last_post'] ? "<a href='".$journal->base_url."user=".$row['journal_id']."' title='".$ibforums->lang['j_tips_lpost']."'>".$journal->get_date($row['j_last_post'])."</a>" : "--";
					$row['j_last_comment'] = $row['j_last_comment'] ? "<a href='".$journal->base_url."user=".$row['journal_id']."&amp;comm=-1&amp;view=last' title='".$ibforums->lang['j_tips_lcomm']."'>".$journal->get_date($row['j_last_comment'])."</a>" : "--";
				}
				if ($row['j_title'] != "") $row['j_title'] = "[ ".$row['j_title']." ]";

				$journal->out_data['pages'] .= $this->html->j_jtr_row($row);
			}
		}
		else $journal->out_data['pages'] .= $this->html->j_jtr_none();
		$journal->out_data['pages'] .= $this->html->j_jtr_end($journal->users['id']);

		$journal->title = $ibforums->lang['j_page_jtrack']." :: ".$journal->users['name']." :: ";
 		$journal->nav[] = "<a href='".$journal->base_url."user=".$journal->users['id']."'>".$journal->users['name']."</a>";
		$journal->nav[] = $ibforums->lang['j_page_jtrack'];
 	}




	// n0  - font name
	// n1  - font size
	// n2  - font bold
	// n3  - font italic
	// n4  - font color
	// n5  - left border size
	// n6  - left border style
	// n7  - left border color
	// n8  - right border size
	// n9  - right border style
	// n10 - right border color
	// n11 - bottom border size
	// n12 - bottom border style
	// n13 - bottom border color
	// n14 - top border size
	// n15 - top border style
	// n16 - top border color
	// n17 - background color

	// convert css style back to array of values
	function remake_style($style)
	{
		$def_value = array("'Verdana, Tahoma, Arial, sans-serif'","'11px'","'normal'","'normal'","'#000000'","'0px'","'none'","'#000000'","'0px'","'none'","'#000000'","'0px'","'none'","'#000000'","'0px'","'none'","'#000000'","'#FFFFFF'");
		$style_id = array(  'font-family','font-size','font-weight','font-style','color',
							'border-left-width','border-left-style','border-left-color',
							'border-right-width','border-right-style','border-right-color',
							'border-bottom-width','border-bottom-style','border-bottom-color',
							'border-top-width','border-top-style','border-top-color',
							'background-color');

		for ($i=0;$i<18;$i++)
		{
			if (preg_match("/\s".$style_id[$i]."[\:](.*?)[\;]/i",$style,$match))
			{
				$def_value[$i] = "'".$match[1]."'";
			}
		}
		return implode(",",$def_value);
	}


	// Design settings
	function page_design()
	{
		global $ibforums, $journal, $DB;

		$style_name = array ('BODY','.tableborder','.jname','.recdata','.rechead','.rec','#QUOTE',
							 '.recparam','.infhead1','.infhead2','.inftext1','.inftext2');

		// Only for owner
		if ($journal->users['id'] != $ibforums->member['id'])
		{
			$journal->err_journal($ibforums->lang['j_err_hack']);
		}

		$this->nav_settings(7);

		if (!$journal->users['g_j_design'])
		{
			$journal->out_data['pages'] .= $this->html->j_page_nodesign();
		}
		else
		{
			$data['key'] = $this->md5_check;
			$data['id'] = $journal->users['id'];

			if (!isset($journal->users['j_skin_css']) or $journal->users['j_skin_css'] == "")
			{
				$journal->users['j_skin_css'] = $journal->skin_set;
			}

			// set current user style
			$skin_names = array();
			$skin_names[0] = $ibforums->lang['j_my_skin'];

			$skin_css = array();
			$skin_css[0] = $journal->users['j_skin_css'];

			// loading style from database
			$DB->query("SELECT * FROM ibf_jskins");
			while ($skin = $DB->fetch_row())
			{
				$skin_names[$skin['sid']+1] = $skin['skin_name'];
				$skin_css[$skin['sid']+1] = $skin['skin_css'];
			}

			// make array of styles
			$skin_js = "var skins = new Array();\n";
			$data['skins'] = "<select name='j_skin_set' class='inftexinput' OnChange='javascript:set_skin_group(this.value);'>";
			foreach ($skin_css as $id => $css)
			{
				$data['skins'] .= "<option value='".$id."'>".$skin_names[$id]."\n";

				$skin_js .= "skins['".$id."'] = new Array();\n";
				for ($j=0; $j<sizeof($style_name);$j++)
				{
					if (preg_match("/".$style_name[$j]."(\s*)[\{](.+?)[\}]/i",$css,$match))
					{
						$skin_js .= "skins['".$id."']['ts".$j."'] = new Array(".$this->remake_style($match[2]).");\n";
					}
				}
			}
			$data['skins'] .= "</select>";

			// moderator options
			if ($ibforums->member['g_j_modview'])
			{
				$data['mod_option'] = $this->html->j_mod_design();
			}

			$journal->out_data['pages'] .= $this->html->j_page_design($data,$skin_js);
		}
		$journal->title = $ibforums->lang['j_page_design']." :: ".$journal->users['name']." :: ";
 		$journal->nav[] = "<a href='".$journal->base_url."user=".$journal->users['id']."'>".$journal->users['name']."</a>";
		$journal->nav[] = $ibforums->lang['j_page_design'];
	}

}
?>